package com.aijia.core.base;

import com.aijia.core.web.ResponseConstant;

import java.io.Serializable;

/**
 *
 * 类名称：Response<br>
 * 类描述：Response 类<br>
 * @version v1.0
 *
 */
public class ResponseEntity implements Serializable{

	private static final long serialVersionUID = 8731218855844435111L;

	private static final String ERROR = "error";
    private static final String SUCCESS = "success";

    private String status;
    private String code;
    private String msg;
    private Object data;

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }

    private static ResponseEntity getInstance(String status, String code, String msg, Object data) {
        ResponseEntity responseEntity = new ResponseEntity();
        responseEntity.setStatus(status);
        responseEntity.setCode(code);
        responseEntity.setMsg(msg);
        responseEntity.setData(data);
        return responseEntity;
    }

    public static ResponseEntity success() {
        return ResponseEntity.getInstance(SUCCESS, ResponseConstant.CODE_999, "成功", null);
    }

    public static ResponseEntity success(String msg) {
        return ResponseEntity.getInstance(SUCCESS, ResponseConstant.CODE_999, msg, null);
    }

    public static ResponseEntity success(Object data) {
        return ResponseEntity.getInstance(SUCCESS, ResponseConstant.CODE_999, "成功", data);
    }

    public static ResponseEntity success(String code, String msg) {
        return ResponseEntity.getInstance(SUCCESS, code, msg, null);
    }

    public static ResponseEntity success(String msg, Object data) {
        return ResponseEntity.getInstance(SUCCESS, ResponseConstant.CODE_999, msg, data);
    }

    public static ResponseEntity failure() {
        return ResponseEntity.getInstance(ERROR, ResponseConstant.CODE_000, "暂未加载到数据，请稍后再试", null);
    }

    public static ResponseEntity failure(String msg) {
        return ResponseEntity.getInstance(ERROR, ResponseConstant.CODE_000, msg, null);
    }

    public static ResponseEntity failure(String code, String msg) {
        return ResponseEntity.getInstance(ERROR, code, msg, null);
    }

    public static ResponseEntity failure(Object data, String msg) {
        return ResponseEntity.getInstance(ERROR, ResponseConstant.CODE_000, msg, data);
    }

    public static ResponseEntity failure(String code, String msg, Object data) {
        return ResponseEntity.getInstance(ERROR, code, msg, data);
    }

}
