package com.aijia.core.web;


import java.beans.IntrospectionException;
import java.beans.Introspector;
import java.util.*;
 
public class MyResponseEntity extends HashMap<String, Object> {

	/**
	 * 
	 */
	private static final long serialVersionUID = -6725416360588540451L;

	public static MyResponseEntity success(String msg){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_OK);
        response.setMsg(msg);
        return response;
    }
	
	public static MyResponseEntity success(int code,String msg){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(code);
        response.setMsg(msg);
        return response;
    }
 
    public static MyResponseEntity failure(String msg){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_500);
        response.setMsg(msg);
        return response;
    }
    
    public static MyResponseEntity failure(int code,String msg){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(code);
        response.setMsg(msg);
        return response;
    }
    
	public static MyResponseEntity success(String key, Object value){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_OK);
        response.setMsg(MyResponseConstant.MSG_OK);
        response.setAny(key, value);
        return response;
    }
	
	public static MyResponseEntity success(Map<String,Object> map){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_OK);
        response.setMsg(MyResponseConstant.MSG_OK);
        response.putAll(map);
        return response;
    }
	
	public static MyResponseEntity success(List<Map<String,Object>> queueList){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_OK);
        response.setMsg(MyResponseConstant.MSG_OK);
        response.setAny("queueList", queueList);
        return response;
    }
	
	public static MyResponseEntity success(List<Map<String,Object>> queueList,int totalSize){
        MyResponseEntity response = new MyResponseEntity();
        response.setCode(MyResponseConstant.CODE_OK);
        response.setMsg(MyResponseConstant.MSG_OK);
        response.setAny("queueList", queueList);
        response.setAny("totalSize", totalSize);
        return response;
    }
	
	public static MyResponseEntity success(Object bean){
		if(bean instanceof Map) {
			return success((Map<String,Object>)bean);
		}
		
		MyResponseEntity response = new MyResponseEntity();
	    response.setCode(MyResponseConstant.CODE_OK);
	    response.setMsg(MyResponseConstant.MSG_OK);
	        
	    response.beanToMap(bean,false);
        return response;
    }
	
	/** 如果returnNull=true,表示对象属性为null也输出
	 * @param bean
	 * @param returnNull
	 * @return
	 */
	public static MyResponseEntity success(Object bean,boolean returnNull){
		if(bean instanceof Map) {
			return success((Map<String,Object>)bean);
		}
		
		MyResponseEntity response = new MyResponseEntity();
	    response.setCode(MyResponseConstant.CODE_OK);
	    response.setMsg(MyResponseConstant.MSG_OK);
	        
	    response.beanToMap(bean,returnNull);
		
        return response;
    }
	
    public MyResponseEntity append(String key, Object value) {
        if (key != null && value != null) put(key, value);
        return this;
    }
 
    private MyResponseEntity setCode(int code) {
        put("code", code);
        return this;
    }
 
    private MyResponseEntity setMsg(String msg) {
        put("msg", msg);
        return this;
    }
 
    private MyResponseEntity setAny(String key, Object value) {
        if (key != null && value != null) put(key, value);
        return this;
    }
    
    private void beanToMap(Object bean,boolean returnNull ) {
	    try {
	        Arrays.asList(Introspector.getBeanInfo(bean.getClass(), Object.class)
	                                          .getPropertyDescriptors())
	                      .stream()
	                      // filter out properties with setters only
	                      .filter(pd -> Objects.nonNull(pd.getReadMethod()))
	                      .forEach(pd -> { // invoke method to get value
	                          try {
	                              Object value = pd.getReadMethod().invoke(bean);
	                              if(returnNull) {
	                            	  put(pd.getName(), value);
	                              }else{
	                            	  if (value != null) {
	                            		  put(pd.getName(), value);
	                            	  }
	                              }
	                          } catch (Exception e) {
	                             e.printStackTrace();
	                          }
	                      });
	    } catch (IntrospectionException e) {
	        	 e.printStackTrace();
	    }
    }
}