package com.aijia.kmt.common.constant;

import com.aijia.kmt.dto.knowledge.KnowledgeBaseDto;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;

public class Knowledge2 {
    private List<KnowledgeBaseDto> chineseList = new ArrayList<>();

    private List<KnowledgeBaseDto> mathList = new ArrayList<>();

    private List<KnowledgeBaseDto> englishList = new ArrayList<>();

    public void init() {
        initChineseList();
        initMathList();
        initEnglishList();
    }

    public void destroy () {

    }

    /**
     * 初始化语文版本
     */
    public void initChineseList () {
        KnowledgeBaseDto temp = new KnowledgeBaseDto(2, "人教(部编)");
        this.chineseList.add(temp);
    }

    /**
     * 初始化数学版本
     */
    public void initMathList () {
        KnowledgeBaseDto renTemp = new KnowledgeBaseDto(2, "人教版");
        this.mathList.add(renTemp);
    }

    /**
     * 初始化英语版本
     */
    public void initEnglishList () {
        KnowledgeBaseDto peopleEducationEdition = new KnowledgeBaseDto(8, "人教版(PEP)");
        this.englishList.add(peopleEducationEdition);
    }



    /**
     * 根据科目返回版本列表
     * @param subject
     * @return
     */
    public List<KnowledgeBaseDto> getVersionListBySubject (String subject) {
        List<KnowledgeBaseDto> result;
        switch (subject){
            case "语文": result = this.chineseList; break;
            case "数学": result = this.mathList; break;
            case "英语": result = this.englishList; break;
            default: result = this.chineseList;
        }
        return result;
    }

    /**
     * 根据科目和版本号获取版本名
     */
    public String getVersionNameBySubjectAndVersionNum(String subject, Integer versionNum) {
        List<KnowledgeBaseDto> knowledgeBaseDtoList = getVersionListBySubject(subject);
        for (KnowledgeBaseDto knowledgeBaseDto : knowledgeBaseDtoList) {
            if (Objects.equals(versionNum, knowledgeBaseDto.getType())) {
                return knowledgeBaseDto.getName();
            }
        }

        return "未知的版本";
    }

    /**
     * 根据科目和版本名获取版本号
     */
    public Integer getVersionNumBySubjectAndVersionName(String subject, String versionName) {
        List<KnowledgeBaseDto> knowledgeBaseDtoList = getVersionListBySubject(subject);
        for (KnowledgeBaseDto knowledgeBaseDto : knowledgeBaseDtoList) {
            if (Objects.equals(versionName, knowledgeBaseDto.getName())) {
                return knowledgeBaseDto.getType();
            }
        }
        return 0;
    }
}
