package com.aijia.kmt.common.taskthread;

import java.util.concurrent.*;

public class AijiaThreadPool {

    /**
     * 核心线程数
     */
    private static int corePoolSize = 10;

    /**
     * 最大线程数
     */
    private static int maximumPoolSize = 100;

    /**
     * 空闲时间
     */
    private static long keepAliveTime = 10;

    /**
     * 空闲时间的单位
     */
    private static TimeUnit unit = TimeUnit.MINUTES;

    /**
     * 等待队列
     */
    private static BlockingQueue<Runnable> workQueue = new ArrayBlockingQueue<Runnable>(1024);

    /**
     * 线程工厂
     */
    //private static ThreadFactory threadFactory;

    /**
     * 拒绝策略
     */
    //private static RejectedExecutionHandler handler;

    public static ThreadPoolExecutor _instance = null;

    /* singleton */
    public static ThreadPoolExecutor getInstance() {
        if (_instance == null) {
            synchronized (AijiaThreadPool.class) {
                if (_instance == null) {
                    _instance = new ThreadPoolExecutor(corePoolSize, maximumPoolSize, keepAliveTime, unit,
                            workQueue, Executors.defaultThreadFactory());
                }
            }
        }
        return _instance;
    }

}
