package com.aijia.kmt.dto;

import com.aijia.kmt.dto.exercise.ExerciseQuestionAnswerSpace;
import com.aijia.kmt.dto.knowledge.KnowledgeBaseDto;
import lombok.Data;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

@Data
public class QuestionListV1Dto implements Serializable {
    private static final long serialVersionUID = 1L;
    private String questionId;
    private String bookName; //练习册名称
    private List<KnowHowDetailsDTO> knowledges; //知识点
    private String questionHtml; //原题目
    private String questionIndex; //题号
    private String questionIndexDesc; //题号描述
    private String answerHtml;  //原答案
    private String dealUser;  //加工人
    private String auditingUser;  //解析人
    private String analysisDealUser; //解析加工人
    private String analysisAuditingUser; // 解析审核人
    private String reason; //打回理由
    private String questionText;  //题目文本
    private List<ExerciseQuestionAnswerSpace> answerJson;
    private int isQuestionCanDeal; //题目是否可以加工
    private int questionStatus; //题目状态，0分配中, 1加工中，2重导中, 3审核中， 4题目已发布， 8解析加工中，10解析审核中， 11解析已发布
    private String analysisHtml; //原解析
    private List<ExerciseQuestionAnswerSpace> analysisJson; //解析json
    private List<KnowledgeBaseDto> questionTypes;
    private List<KnowledgeBaseDto> difficultyLevels;
    private List<KnowledgeBaseDto> realExamTypes;
    private List<KnowledgeBaseDto> trainingSkills;
    private  int num; //排序号
    private int pageIndex; //页码
    private String questionImage;
    private int isCommonFlag; //是否共用， 默认0 不显示， 1 共用
    private int startX; //开始x
    private int startY; //开始y
    private int endX; //结束x
    private int endY; //结束y
    private int enumerate; //题号覆盖类型
    private String fromUser; //打回人
    private String toUser; //被打回人
    private int proofreadStatus; //	0未校对, 1答案正确，2答案错误, 3管理员已修改
    private List<QuestionListV1Dto> childQuestions = new ArrayList<>(); //必须先初始化
}
