package com.aijia.kmt.mapper;

import com.aijia.kmt.po.FileInfo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface FileInfoMapper extends BaseMapper<FileInfo> {

	@Select("SELECT * FROM `sys_file_info`  t where t.user_id='FACEWORK' AND TO_DAYS(t.created_date)=TO_DAYS(#{date})  ORDER BY t.created_date ASC  ")
	public List<FileInfo> findFileInfoByDate(@Param("date") String date);

	@Select("DELETE from   sys_file_info where file_path =#{filePath}")
	public void deleteByFilePath(@Param("filePath") String filePath);

	@Select("SELECT  *  from  sys_file_info where file_code =#{fileCode} LIMIT #{star},#{end}")
	public List<FileInfo> findFileInfoByFileCode(@Param("fileCode") String fileCode,@Param("star") int star,@Param("end") int end);

	@Select("SELECT  count(1)  from  sys_file_info where file_code = (\n" +
			"SELECT  file_code  from  sys_file_info where user_id =#{userId}\n" +
			"and  file_path  =#{filePath})")
	public Long countFileInfoByFilePathAndUserId(@Param("userId") String userId,@Param("filePath") String filePath);
	
	
}
