package com.aijia.kmt.mapper;

import com.aijia.kmt.po.KmtExerciseBookCourse;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface KmtExerciseBookCourseMapper extends BaseMapper<KmtExerciseBookCourse> {

    @Select("SELECT * FROM kmt_exercise_book_course where book_id=#{BookId} limit 1")
    public KmtExerciseBookCourse findOneByBookId (@Param("BookId") String BookId);

    /**
     * 查询单元课时列表
     * @param unitId
     * @return
     */
    @Select("SELECT * FROM kmt_exercise_book_course where unit_id=#{unitId}")
    public List<KmtExerciseBookCourse> findByUnitId (@Param("unitId") String unitId);
//    public List<KmtExerciseBookCourse> findByUnitId (String unitId);

    /**
     * 查询
     * @param bookId
     * @return
     */
    @Select("SELECT * FROM kmt_exercise_book_course where book_id=#{bookId}")
    public List<KmtExerciseBookCourse> findByBookId (@Param("bookId")String bookId);
//    public List<KmtExerciseBookCourse> findByBookId (String bookId);


    /**
     * 根据题目查询科目
     * @param questionId
     * @return
     */
    @Select("SELECT eq.course_name FROM kmt_exercise_questions eq left join kmt_exercise_book_course ebc on eq.book_course_id=ebc.id where eq.id=#{questionId}")
    public String findCourseNameByQuestionId (@Param("questionId") String questionId);

    List<KmtExerciseBookCourse> findByBookIdIn(@Param("bookIds") List<String> bookIds);

}
