package com.aijia.kmt.mapper;

import com.aijia.kmt.po.KmtExerciseBook;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
//public interface KmtExerciseBookMapper extends JpaRepository<KmtExerciseBook, String> {
public interface KmtExerciseBookMapper extends BaseMapper<KmtExerciseBook> {

    @Select("select * from kmt_exercise_book where book_name=#{bookName} and grade=#{grade} and course_name=#{courseName} and semester=#{semester} and version=#{version} and book_year=#{bookYear} and book_type=#{bookType} limit 1 ")
    KmtExerciseBook findTopByBookNameAndGradeAndCourseNameAndSemesterAndVersionAndBookYearAndBookType(String bookName, String grade, String courseName, int semester, int version, int bookYear, int bookType);

    @Select("update kmt_exercise_book set answer_correcter_id = #{teacherId} where id = #{exerciseBookId}")
    void updateAnswerCorrecterIdById(@Param("teacherId") String teacherId,@Param("exerciseBookId") String exerciseBookId);

    void updateAnswerCorrecterIdByIds(@Param("teacherId") String teacherId,@Param("exerciseBookIds") List<String> exerciseBookIds);

    void updateHandleUserIdByIds(@Param("teacherId") String teacherId,@Param("exerciseBookIds") List<String> exerciseBookIds);

    void updateAuditingUserId(@Param("teacherId") String teacherId,@Param("exerciseBookIds") List<String> exerciseBookIds);

    void updateAnalysisUserId(@Param("teacherId") String teacherId,@Param("exerciseBookIds") List<String> exerciseBookIds);

    void updateAnalysisAuditerId(@Param("teacherId") String teacherId,@Param("exerciseBookId") List<String> exerciseBookIds);

    @Select("select * from kmt_exercise_book where version_name is null ")
    List<KmtExerciseBook> findByVersionNameIsNull();

    @Select("select * from kmt_exercise_book where course_name=#{courseName}")
    List<KmtExerciseBook> findByCourseName(@Param("courseName") String courseName);

    @Select("select * from kmt_exercise_book where course_name=#{courseName} and version=#{version}")
    List<KmtExerciseBook> findByCourseNameAndVersion(@Param("courseName") String courseName,@Param("version") int version);

    @Select("select * from kmt_exercise_book where lib_name not null")
    List<KmtExerciseBook> findByLibNameIsNotNull();

    /**
     * 更新kmt_exercise_book.status
     *
     * @param exerciseBookId 练习册id
     * @param status status更新为？
     */
    @Select("update kmt_exercise_book set status = #{status} where id = #{exerciseBookId} ")
    void updateExerciseBookStatus(@Param("exerciseBookId") String exerciseBookId,@Param("status") String status);

//    @Select("select * from kmt_exercise_book where id=#{bookID} limit 1")
//    KmtExerciseBook selectById(@Param("bookID") String bookID);

    @Select("select * from kmt_exercise_book")
    List<KmtExerciseBook> findAll();
    
    KmtExerciseBook selectByExeriseId(@Param("exerciseBookId") String exerciseBookId,@Param("bookYear") int bookYear);

    @Select("select eb.* from kmt_exercise_book eb, kmt_exercise_questions eq where eb.id=eq.exercise_book_id and eq.id=#{questionId}")
    KmtExerciseBook findExerciseBookByQuestionId (@Param("questionId") String questionId);

    @Select("select ${fieldName} from kmt_exercise_book where book_id=#{bookId} limit 1")
    String findAuditingUserIdByBookId(@Param("bookId") String bookId, @Param("fieldName") String fieldName);

    @Select("select ${fieldName} from kmt_exercise_book where id=#{id} limit 1")
    String findAuditingUserIdById(@Param("id") String id, @Param("fieldName") String fieldName);


}
