package com.aijia.kmt.mapper;

import com.aijia.kmt.dto.BookDTO;
import com.aijia.kmt.po.KmtExerciseBookCourse;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;

import java.util.List;
import java.util.Map;

@Mapper
public interface KmtExerciseQueryMapper{

    /**
     * 查询练习册题目关联的知识点
     * @param questionIds 题目列表
     * @return
     */
    public List<Map<String, Object>> findHowDetailNameByQuestionIds (@Param("questionIds") List<String> questionIds,@Param("versiontType") int versiontType);


    /**
     * 查询所有的练习册-单元-课时记录
     * @param subject 科目
     * @param grade 年级
     * @param semester 上下册
     * @param versionType 版本类型
     * @return
     */
    public List<KmtExerciseBookCourse> getAllBookCourse (@Param("subject") String subject,@Param("grade") String grade,@Param("semester") int semester,@Param("versionType") int versionType);


    /**
     * 根据年级、科目分页查询教辅列表
     * @param grade
     * @param subject 科目
     * @param bookName
     * @param pageable 分页信息
     * @return
     */
    Page<BookDTO> findBookPage(@Param("garde") String grade,@Param("subject") String subject,@Param("bookName") String bookName,@Param("pageable") Pageable pageable);

    /**
     * 查询练习册信息
     * @param bookIds
     * @return
     */
    List<KmtExerciseBookCourse> findBookDataByBookIds (@Param("bookIds") List<String> bookIds);
}
