package com.aijia.kmt.mapper;

import com.aijia.kmt.po.KmtExerciseQuestionKnow;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface KmtExerciseQuestionKnowMapper extends BaseMapper<KmtExerciseQuestionKnow> {

    /**
     * 根据题目的id集合查询关联知识点
     */
//    @Select("select * from kmt_exercise_question_know where question_id in")
    List<KmtExerciseQuestionKnow> findByQuestionIdIn(@Param("wrongQuestionIdList") List<String> wrongQuestionIdList);
    /**
     * 根据题目的id查询关联知识点
     */
    @Select("select * from kmt_exercise_question_know where question_id = #{questionId} ")
    List<KmtExerciseQuestionKnow> findByQuestionId(@Param("questionId") String questionId);

    /**
     * 删除关联的知识点
     * @param questionIds
     */
//    @Select("delete from kmt_exercise_question_know where question_id in (?1)")
    void deleteByQuestionId(List<String> questionIds);


}
