package com.aijia.kmt.mapper;

import com.aijia.kmt.po.KmtExerciseQuestion;
import com.aijia.kmt.po.KmtExerciseQuestionKnow;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;

@Mapper
public interface KmtExerciseQuestionMapper extends BaseMapper<KmtExerciseQuestion> {

    @Select("select * from kmt_exercise_question_know where question_id=#{questionId}")
    List<KmtExerciseQuestionKnow> findByQuestionId(@Param("questionId") String questionId);

    @Update("update kmt_exercise_questions set num= num - 1 where book_id=#{bookId}  and num>#{num}")
    int updateQuestions(@Param("bookId") String bookId,@Param("num") int num);

    @Update("update kmt_exercise_questions set num= num - #{questionsNum} where book_id=#{bookId}  and num>#{num}")
    int updateBigQuestion(@Param("bookId") String bookId,@Param("questionsNum") int questionsNum,@Param("num") int num);

    @Select("select id from kmt_exercise_questions where parent_id=#{parentId} and num>#{num}")
    List<String> findQuestions(@Param("parentId") String parentId,@Param("num") int num);

/*    @Update({
            "<script>",
            "update kmt_exercise_questions set num= num + 1 where id in",
            "<foreach collection='questionsId' item='questionId' open='(' separator=',' close=')'>",
            "#{questionId}",
            "</foreach>",
            "</script>"
    })
    int updateQuestions(@Param("questionsId") List<String> questionsId);*/

    /**
     * 根据课时id查询题目
     * @param periodId 课时id
     */
    @Select("select * from kmt_exercise_question_know where book_course_id=#{periodId} order by num,create_time asc ")
    List<KmtExerciseQuestion> findByBookCourseId(@Param("periodId") String periodId);

    /**
     * 根据单元id查询题目
     * @param unitId 单元id
     */
    @Select("select * from kmt_exercise_question_know where unit_id=#{unitId}")
    List<KmtExerciseQuestion> findByUnitId(@Param("unitId") String unitId);

    /**
     * 根据练习册id查询题目
     * @param bookId 练习册id
     */
    @Select("select * from kmt_exercise_question_know where book_id = #{bookId}")
    List<KmtExerciseQuestion> findByBookId(@Param("bookId") String bookId);


    @Select("select * from kmt_exercise_question_know where id = #{questionId}")
    KmtExerciseQuestion getById(@Param("questionId") String questionId);
    
    @Select("SELECT	t.*, c.course_name AS course, "
    		+ "	c.unit_name, "
    		+ "	c.number, "
    		+ " c.page_index as page_index_new, "
    		+ " c.sort_number "
    		+ " FROM"
    		+ " q_question_workbook c "
    		+ " inner JOIN kmt_exercise_questions t ON t.id = c.question_id"
    		+ " WHERE"
    		+ "	c.sub_book_id = #{bookId}"
    		+ " AND c.question_id = #{questionId}")  
    KmtExerciseQuestion findPreviousById(@Param("bookId") String bookId,
                                                   @Param("questionId") String questionId);
    
    @Select("SELECT	t.*, c.course_name AS course, "
    		+ "	c.unit_name, "
    		+ "	c.number, "
    		+ " c.page_index as page_index_new, "
    		+ " c.sort_number "
    		+ " FROM"
    		+ " q_question_workbook c "
    		+ " LEFT JOIN kmt_exercise_questions t ON t.id = c.question_id"
    		+ " AND t.exercise_book_id = c.sub_book_id"
    		+ " WHERE"
    		+ "	c.sub_book_id = #{bookId}"
    		+ " AND c.question_id = #{questionId}")  
    KmtExerciseQuestion findPreviousBySubBookId(@Param("bookId") String bookId,
                                                   @Param("questionId") String questionId);

    @Update({
            "<script>",
            "update kmt_exercise_questions set deal_status=#{dealStatus} where id in",
            "<foreach collection='questionIds' item='questionId' open='(' separator=',' close=')'>",
            "#{questionId}",
            "</foreach>",
            "</script>"
    })
    int updateQuestionDealStatus (@Param("questionIds") List<String> questionIds, @Param("dealStatus") int dealStatus);


    @Select("select count(1) from kmt_exercise_questions where parent_id=#{parentId} and deal_status !=6")
    Integer countChildQuestions (@Param("parentId") String parentId);

}
