package com.aijia.kmt.mapper;

import com.aijia.kmt.po.KmtExerciseBookTeacherRecord;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

//public interface KmtExerciseTeacherRecordMapper extends JpaRepository<KmtExerciseBookTeacherRecord, String> {
@Mapper
public interface KmtExerciseTeacherRecordMapper extends BaseMapper<KmtExerciseBookTeacherRecord> {
    /**
     * 查询最新的分配记录
     * @param exerciseBookId
     * @param type
     * @return
     */
    @Select("select * from kmt_exercise_book_teacher_record where exercise_book_id =#{exerciseBookId} and authority_type =#{type} " +
            " order by create_time desc limit 1")
    KmtExerciseBookTeacherRecord findByExerciseBookIdAndAuthorityType (@Param("exerciseBookId") String exerciseBookId,@Param("type") int type);

    /**
     * 查询最新的分配记录
     *
     * @param exerciseBookId 练习册id
     *
     * @param lastFlag 是否最新
     * @return 分配记录list
     */
    @Select("select * from kmt_exercise_book_teacher_record where exercise_book_id=#{exerciseBookId} and last_flag = #{lastFlag}")
    List<KmtExerciseBookTeacherRecord> findByExerciseBookIdAndLastFlag(@Param("exerciseBookId") String exerciseBookId,@Param("lastFlag") int lastFlag);

}
