package com.aijia.kmt.mapper;


import com.aijia.kmt.dto.ExerciseQuetionDto;
import com.aijia.kmt.dto.KmtTeacherDetailDto;
import com.aijia.kmt.po.KmtQualityQuestionKnow;
import com.aijia.kmt.po.KmtQualityQuestionRollback;
import com.aijia.kmt.po.KmtQualityQuestions;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;
import java.util.Map;

@Mapper
public interface KmtQualityQuestionsMapper extends BaseMapper<KmtQualityQuestions> {

    /**
     * 查询搜索的题目, kmt_exercise_questions, kmt_sys_user
     * @param questionId
     * @return
     */
    List<ExerciseQuetionDto> findKmtQuestionsById(@Param("questionId") String questionId,
                                                  @Param("userId") String userId,
                                                  @Param("dealType") int dealType,
                                                  Page page);

    /**
     * 查询大题 kmt_exercise_questions
     * @param id
     * @return
     */
    ExerciseQuetionDto findBigQuestionById(@Param("id") String id);

    /**
     * 根据练习册id列表查询需要更新到es的数据
     * @param questionIdList 题目id列表
     */
    List<Map<String, Object>> findData2EsByQuestionList(@Param("questionIdList") List<String> questionIdList);

    /**
     * 查询大标题以及大标题下的所有小题 kmt_exercise_questions
     * @param parentIds
     * @return
     */
    List<KmtQualityQuestions> findQuestionByParentId(@Param("parentIds") List<String> parentIds);

    /**
     * 查询kmt题目知识点
     * @param questionId
     * @return
     */
    List<KmtQualityQuestionKnow> findQualityQuestionKnowByQuestionId(@Param("questionId") String questionId);

    /**
     * 查询打回记录
     * @param questionId
     * @return
     */
    List<KmtQualityQuestionRollback> findKmtQualityQuestionRollbackListByQuestionId(@Param("questionId") String questionId);

    @Select("select auditing_user_id from kmt_quality_teacher_import_relationship where import_teacher_id=#{teacherId} " +
            "and status=1 limit 1")
    String findAuditingUserIdByImportTeacherId(@Param("teacherId") String teacherId);

    /**
     * 查询kmt加工审核老师详情列表
     * @param userId
     * @param detailName 搜索的知识点名称
     * @param page
     * @return
     */
    List<KmtTeacherDetailDto> findKmtTeacherDetails (@Param("userId")String userId,
                                                     @Param("detailName")String detailName,
                                                     @Param("type")int type,
                                                     Page page);


    @Select("select id from kmt_quality_questions order by id")
    List<String> findPageQuestionIds (Page page);
}
