package com.aijia.kmt.mapper;

import com.aijia.kmt.po.user.TbLibManagerAudit;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

@Mapper
public interface LibManagerAuditMapper extends BaseMapper<TbLibManagerAudit> {

    /**
     * 查询对应审批记录
     *
     * @param libManagerId
     * @param status
     * @return
     */
    @Select("select * from tb_lib_manager_audit where lib_manager_id = #{libManagerId} and status=#{status} order by create_time desc")
    List<TbLibManagerAudit> findByLibManagerIdAndStatus(@Param("libManagerId") String libManagerId,
                                                        @Param("status") int status);

    @Select("select * from tb_lib_manager_audit where user_id = #{teacherId} and type=#{type} and status=#{status} order by create_time desc limit 1")
    TbLibManagerAudit findByUserIdAndTypeAndStatus(@Param("teacherId")String teacherId,
                                                   @Param("type")int type,
                                                   @Param("status")int status);

    /**
     * 根据管理员id查询最新的一条申请记录
     */
    @Select("select * from tb_lib_manager_audit where lib_manager_id = #{libManagerId} order by create_time desc limit 1")
    TbLibManagerAudit findLastOneByLibManagerId(String libManagerId);

    /**
     * 根据管理员id查询最新的一条申请记录
     */
    @Select("select * from tb_lib_manager_audit where lib_manager_id = #{libManagerId} order by create_time desc limit 1")
    List<TbLibManagerAudit> findAllByLibManagerId(String libManagerId);

    @Select("select count(distinct user_id) from tb_lib_manager_audit where type=17 and status=3")
    int findUnOperateNum();
}
