package com.aijia.kmt.mapper;


import com.aijia.kmt.dto.exercise.QuestionWorkbookNumberSize;
import com.aijia.kmt.po.QuestionWorkbook;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;


@Mapper
public interface QuestionWorkbookMapper extends BaseMapper<QuestionWorkbook> {
	List<QuestionWorkbook> findNeedUpdateNumberQuestionWorkBook (@Param("bookId") String bookId);

	List<QuestionWorkbookNumberSize> findQuestionQuestionWorkBook (@Param("bookId") String bookId);
	
	void updateNumberByBookIdAndQuestionId(@Param("bookId") String bookId,
										   @Param("questionId") String questionId,
										   @Param("number") int number);
	
	void deleteQuestionByQuestionIdAndBookId(@Param("questionId") String questionId,@Param("bookId") String bookId);
	
	void deleteQuestions(@Param("bookId")String bookId, @Param("questionIds") List<String> questionIds);
	
	List<String> queryBookIds(@Param("questionId") String questionId);

	List<String> queryBookIdsByQuestionIds(List<String> questionIds);
	
	List<Integer> querySortNumberByParentQuestionId(@Param("parentQuestionId") String parentQuestionId,@Param("bookId") String bookId);
	
	void updateSortNumberByQuestionId(@Param("questionId") String questionId,@Param("subBookId") String subBookId,@Param("sortNumber")Integer sortNumber);
	
	String queryBookId(@Param("questionId") String questionId,@Param("subBookId") String subBookId);

	//根据单元，课时，bookid查询所有大题的sortNumber
	List<QuestionWorkbook> queryBigQuestionSortNumber(@Param("unitName") String unitName,@Param("courseName") String courseName,@Param("bookId") String bookId);
	
	List<QuestionWorkbook> querySmallQuestionByParentQuestionId(@Param("parentQuestionId") String parentQuestionId,@Param("bookId") String bookId);
	
	QuestionWorkbook queryQuestionWorkbook(@Param("questionId") String questionId,@Param("bookId") String bookId);

	List<Map<String, Object>> findExerciseBookQuestions (@Param("bookId") String bookId);


    List<Map<String, Object>> findExerciseBookQuestionsOrderByNum(String bookId);
}
