package com.aijia.kmt.mapper;

import com.aijia.kmt.po.TeacherEnrollment;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.springframework.stereotype.Repository;

/**
 * @apiNote 
 * 
 * @author yrf 
 * @date 2020/12/31 11:24
 */
@Repository
@Mapper
public interface TeacherEnrollmentMapper extends BaseMapper<TeacherEnrollment> {

    @Delete("delete from tb_teacher_enrollment where  phone_number=#{phoneNumber}")
    int deleteByPhoneNumber(@Param("phoneNumber") String phoneNumber);

    @Select("select * from tb_teacher_enrollment where name regexp #{searchKey} or phone_number regexp #{searchKey} order by create_time desc")
    IPage<TeacherEnrollment> findTeacherEnrollmentList (@Param("searchKey") String searchKey, Page page);
}
