package com.aijia.kmt.mapper;

import com.aijia.kmt.dto.questionexport.ExerciseBookDto;
import com.aijia.kmt.po.Workbook;
import com.aijia.kmt.vo.questionexport.ExerciseBookListRequest;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.Update;

import java.util.List;


@Mapper
public interface WorkbookMapper extends BaseMapper<Workbook>{

    List<ExerciseBookDto> findExerciseBookList (@Param("req")ExerciseBookListRequest req,
                                                Page page);


    @Select("select * from q_workbook where book_grade=#{grade} and book_subject=#{subject} and version_code=#{versionCode} " +
            " and semester=#{semester} and book_name=#{bookName} order by create_time desc limit 1")
    Workbook findWorkBookByGradeSubjectSemesterVersionCode(@Param("grade") String grade,
                                                           @Param("subject") String subject,
                                                           @Param("versionCode") int versionCode,
                                                           @Param("semester") int semester,
                                                           @Param("bookName") String bookName);

    @Update("update kmt_exercise_book set parent_book_id=#{parentBookId} where grade=#{grade} and course_name=#{subject} " +
            "  and version=#{versionCode} and semester=#{semester} " +
            " and book_name=#{bookName} and parent_book_id is null")
    int updateExerciseBookParentBookId (@Param("grade") String grade,
                                        @Param("subject") String subject,
                                        @Param("versionCode") int versionCode,
                                        @Param("semester") int semester,
                                        @Param("bookName") String bookName,
                                        @Param("parentBookId") String parentBookId);
}
