package com.aijia.kmt.po;

import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @author yrf
 * @date 2020/6/2 10:33
 */
@Entity
@Table(name = "kmt_exercise_book_distribution_count")
@TableName(value = "kmt_exercise_book_distribution_count")
public class KmtExerciseBookDistributionCount extends BaseEntity {

    private static final long serialVersionUID = -4723210268086837591L;

    /**
     * 练习册id
     */
    private String exerciseBookId;

    /**
     * 练习册导入时间
     */
    private Date importDate;

    /**
     * 练习册名称
     */
    private String bookName;

    /**
     * 科目
     */
    private String subject;

    /**
     * 年级
     */
    private String grade;

    /**
     * 版本
     */
    private Integer version;

    /**
     * 上下册（1：上；2：下）
     */
    private Integer semester;

    /**
     * 练习册类型，0整本,1上半本，2下半本，3完成不同的页码的新版练习册
     */
    private Integer bookType;

    /**
     * 单元总数
     */
    private Integer unitCount = 0;

    /**
     * 课时总数
     */
    private Integer courseCount = 0;

    /**
     * 加工人名称
     */
    private String handlerName;

    /**
     * 加工人最新提交时间
     */
    private Date handlerLastSubmitTime;

    /**
     * 加工人结薪状态（0：未结薪；1已结薪）
     */
    private Integer handlerSalaryGiven = 0;

    /**
     * 加工人结薪时间
     */
    private Date handlerSalaryGivenTime;

    /**
     * 加工正确率
     */
    private Integer handlerAccuracy = 0;

    /**
     * 加审人名称
     */
    private String handleAuditUserName;

    /**
     * 加审人最新提交时间
     */
    private Date handleAuditUserLastSubmitTime;

    /**
     * 加审人结薪状态（0：未结薪；1已结薪）
     */
    private Integer handleAuditUserSalaryGiven = 0;

    /**
     * 加审人结薪时间
     */
    private Date handleAuditUserSalaryGivenTime;

    /**
     * 加审正确率
     */
    private Integer handleAuditUserAccuracy = 0;

    /**
     * 加工人名称
     */
    private String analyserName;

    /**
     * 加工人最新提交时间
     */
    private Date analyserLastSubmitTime;

    /**
     * 加工人结薪状态（0：未结薪；1已结薪）
     */
    private Integer analyserSalaryGiven = 0;

    /**
     * 加工人结薪时间
     */
    private Date analyserSalaryGivenTime;

    /**
     * 加工正确率
     */
    private Integer analyserAccuracy = 0;

    /**
     * 解审人名称
     */
    private String analysisAuditUserName;

    /**
     * 解审人最新提交时间
     */
    private Date analysisAuditUserLastSubmitTime;

    /**
     * 解审人结薪状态（0：未结薪；1已结薪）
     */
    private Integer analysisAuditUserSalaryGiven = 0;

    /**
     * 解审人结薪时间
     */
    private Date analysisAuditUserSalaryGivenTime;

    /**
     * 练习册状态（1：加工中；2：加工审核中；3：解析中；4：解析审核中；5：已发布）
     */
    private Integer bookStatus;

    /**
     * 最后一次更新时间
     */
    private Date updateTime;

    /**
     * 创建时间
     */
    private Date createTime;

    public String getExerciseBookId() {
        return exerciseBookId;
    }

    public void setExerciseBookId(String exerciseBookId) {
        this.exerciseBookId = exerciseBookId;
    }

    public Date getImportDate() {
        return importDate;
    }

    public void setImportDate(Date importDate) {
        this.importDate = importDate;
    }

    public String getBookName() {
        return bookName;
    }

    public void setBookName(String bookName) {
        this.bookName = bookName;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public Integer getVersion() {
        return version;
    }

    public void setVersion(Integer version) {
        this.version = version;
    }

    public Integer getSemester() {
        return semester;
    }

    public void setSemester(Integer semester) {
        this.semester = semester;
    }

    public Integer getBookType() {
        return bookType;
    }

    public void setBookType(Integer bookType) {
        this.bookType = bookType;
    }

    public Integer getUnitCount() {
        return unitCount;
    }

    public void setUnitCount(Integer unitCount) {
        this.unitCount = unitCount;
    }

    public Integer getCourseCount() {
        return courseCount;
    }

    public void setCourseCount(Integer courseCount) {
        this.courseCount = courseCount;
    }

    public String getHandlerName() {
        return handlerName;
    }

    public void setHandlerName(String handlerName) {
        this.handlerName = handlerName;
    }

    public Date getHandlerLastSubmitTime() {
        return handlerLastSubmitTime;
    }

    public void setHandlerLastSubmitTime(Date handlerLastSubmitTime) {
        this.handlerLastSubmitTime = handlerLastSubmitTime;
    }

    public Integer getHandlerSalaryGiven() {
        return handlerSalaryGiven;
    }

    public void setHandlerSalaryGiven(Integer handlerSalaryGiven) {
        this.handlerSalaryGiven = handlerSalaryGiven;
    }

    public Date getHandlerSalaryGivenTime() {
        return handlerSalaryGivenTime;
    }

    public void setHandlerSalaryGivenTime(Date handlerSalaryGivenTime) {
        this.handlerSalaryGivenTime = handlerSalaryGivenTime;
    }

    public Integer getHandlerAccuracy() {
        return handlerAccuracy;
    }

    public void setHandlerAccuracy(Integer handleAccuracy) {
        this.handlerAccuracy = handleAccuracy;
    }

    public String getHandleAuditUserName() {
        return handleAuditUserName;
    }

    public void setHandleAuditUserName(String handleAuditUserName) {
        this.handleAuditUserName = handleAuditUserName;
    }

    public Date getHandleAuditUserLastSubmitTime() {
        return handleAuditUserLastSubmitTime;
    }

    public void setHandleAuditUserLastSubmitTime(Date handleAuditUserLastSubmitTime) {
        this.handleAuditUserLastSubmitTime = handleAuditUserLastSubmitTime;
    }

    public Integer getHandleAuditUserSalaryGiven() {
        return handleAuditUserSalaryGiven;
    }

    public void setHandleAuditUserSalaryGiven(Integer handleAuditUserSalaryGiven) {
        this.handleAuditUserSalaryGiven = handleAuditUserSalaryGiven;
    }

    public Date getHandleAuditUserSalaryGivenTime() {
        return handleAuditUserSalaryGivenTime;
    }

    public void setHandleAuditUserSalaryGivenTime(Date handleAuditUserSalaryGivenTime) {
        this.handleAuditUserSalaryGivenTime = handleAuditUserSalaryGivenTime;
    }

    public Integer getHandleAuditUserAccuracy() {
        return handleAuditUserAccuracy;
    }

    public void setHandleAuditUserAccuracy(Integer handleAuditUserAccuracy) {
        this.handleAuditUserAccuracy = handleAuditUserAccuracy;
    }

    public String getAnalyserName() {
        return analyserName;
    }

    public void setAnalyserName(String analyserName) {
        this.analyserName = analyserName;
    }

    public Date getAnalyserLastSubmitTime() {
        return analyserLastSubmitTime;
    }

    public void setAnalyserLastSubmitTime(Date analyserLastSubmitTime) {
        this.analyserLastSubmitTime = analyserLastSubmitTime;
    }

    public Integer getAnalyserSalaryGiven() {
        return analyserSalaryGiven;
    }

    public void setAnalyserSalaryGiven(Integer analyserSalaryGiven) {
        this.analyserSalaryGiven = analyserSalaryGiven;
    }

    public Date getAnalyserSalaryGivenTime() {
        return analyserSalaryGivenTime;
    }

    public void setAnalyserSalaryGivenTime(Date analyserSalaryGivenTime) {
        this.analyserSalaryGivenTime = analyserSalaryGivenTime;
    }

    public Integer getAnalyserAccuracy() {
        return analyserAccuracy;
    }

    public void setAnalyserAccuracy(Integer analyserAccuracy) {
        this.analyserAccuracy = analyserAccuracy;
    }

    public String getAnalysisAuditUserName() {
        return analysisAuditUserName;
    }

    public void setAnalysisAuditUserName(String analysisAuditUserName) {
        this.analysisAuditUserName = analysisAuditUserName;
    }

    public Date getAnalysisAuditUserLastSubmitTime() {
        return analysisAuditUserLastSubmitTime;
    }

    public void setAnalysisAuditUserLastSubmitTime(Date analysisAuditUserLastSubmitTime) {
        this.analysisAuditUserLastSubmitTime = analysisAuditUserLastSubmitTime;
    }

    public Integer getAnalysisAuditUserSalaryGiven() {
        return analysisAuditUserSalaryGiven;
    }

    public void setAnalysisAuditUserSalaryGiven(Integer analysisAuditUserSalaryGiven) {
        this.analysisAuditUserSalaryGiven = analysisAuditUserSalaryGiven;
    }

    public Date getAnalysisAuditUserSalaryGivenTime() {
        return analysisAuditUserSalaryGivenTime;
    }

    public void setAnalysisAuditUserSalaryGivenTime(Date analysisAuditUserSalaryGivenTime) {
        this.analysisAuditUserSalaryGivenTime = analysisAuditUserSalaryGivenTime;
    }

    public Integer getBookStatus() {
        return bookStatus;
    }

    public void setBookStatus(Integer bookStatus) {
        this.bookStatus = bookStatus;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}