package com.aijia.kmt.po;

import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import javax.persistence.Column;
import javax.persistence.Transient;
import java.util.Date;

//@Entity
//@Table(name="kmt_exercise_questions")
@TableName(value="kmt_exercise_questions")
public class KmtExerciseQuestion extends BaseEntity {

	private static final long serialVersionUID = 3061402905883944457L;

	private String bookId;  //练习册id
    private String unitId;//单元id
	private String bookCourseId;//单元课时id
    private Integer questionType = 0;//题目类型，1：选择题2：多选项3：填空题4：简答题6：计算题7：作文题8：判断题9：连线题10：翻译题11：匹配题12：阅读题13：语音题14：操作题16：课外阅读题17：解决问题18：看图列式19：情景交际
    private String source;//来源, "题库录入"
    private String bigQuestionIndex;//大题号，如：一、二
    private Date analysisSubmitTime;
    private Integer pageIndex = 1;//页码
    private String image;//图片路径
    private String precisionPercent;//识别精确率
    private Date createTime;//创建时间
    private String auditingUserId;//审核人
    private String handleUserId;//加工人
    private Integer dealStatus;//状态，0已录入, 1重加工, 2打回ai, 3已加工待审核, 4审核已提交，未分配解析加工人，5解析加工中，6已删除，7打回审核，8解析打回加工中，9解析审核中，10解析打回审核中，11已发布
    private String remark;//备注
    private Integer analysisSubmitType = 0;//解析加工的类型：0未解析，1已提交解析
    private String answerImage;//答案原图
    private Integer num = 0; //排序
    private String smallQuestionName;//小题名称
    private String parentId = "";//父题id
    private String bigName;//大题名称
    private String realExamType;//真题，例题类型，1例题，2真题，3练习题
    private Date publishTime;//发布时间
    private int updateType; // 更新类型，默认0， 3拆题新增的题目， 4题库录入的题目
    private String analysisUserId;//解析人
    private Integer difficultyLevel = 0;
    private String courseName;
    private String trainingSkill;//训练的技能
    private String conciseId;//年级科目版本信息id
    private String analysisAuditerId;//解析加工员
    private Integer esLoaded = 0;//是否已加载到es（-1关联教辅不存在；0未加载；1已加载；2加载失败）
    private Integer isCommonFlag = 0;//是否是共享题 0共享题，1非共享题， kmt题库：1有解析的题目， 0无解析题目
    private Integer questionYear = 2019;
    @TableField(updateStrategy = FieldStrategy.NEVER)
    private String exerciseBookId;
    private Date handlerSubmitTime;//题目加工人提交时间
    private Date analysisHandlerSubmitTime;//解析加工人提交时间
    private Integer questionClassType = 0;//kmt题库题目类型，0单题， 1大标题，2大标题下的小题
    private String conciseBakId;
    private Date repulseTime;//打回时间
    private String fromUserId;
    private String toUserId;
    private String answerCorrecterId;//答案校对员用户id
    private int proofreadStatus;//答案校对状态， 0未校对, 1答案正确，2答案错误, 3管理员已修改
    private String questionPath;//题目信息文件路径
	private int enumerate=1;
	
	@TableField(exist=false)
	private String course="";// 课时名称 new
	@TableField(exist=false)
	private String unitName="";// 单元名称 new
	@TableField(exist=false)
	private Integer number=0;// 题目排序 new
	@TableField(exist=false)
	private Integer pageIndexNew=0;//题目页码
	@TableField(exist=false)
	private Integer sortNumber=0;

    //以下字段不在数据库中存储
	@TableField(exist=false)
    private String question;//题目
	@TableField(exist=false)
	private String optionAnswer;//答案
	@TableField(exist=false)
	private String questionText; //题目文本
	@TableField(exist=false)
	private String questionJson;
	@TableField(exist=false)
	private String answerJson;
	@TableField(exist=false)
	private String analysis;
	@TableField(exist=false)
	private String analysisJson;
	@TableField(exist=false)
	private String optionAnswerText;
	public Date getRepulseTime() {
		return repulseTime;
	}

	public void setRepulseTime(Date repulseTime) {
		this.repulseTime = repulseTime;
	}

	public int getEnumerate() {
		return enumerate;
	}

	public void setEnumerate(int enumerate) {
		this.enumerate = enumerate;
	}

	@Transient
	public String getQuestionText() {
		return questionText;
	}

	public void setQuestionText(String questionText) {
		this.questionText = questionText;
	}

	public int getUpdateType() {
		return updateType;
	}

	public void setUpdateType(int updateType) {
		this.updateType = updateType;
	}

	public String getBookId() {
		return bookId;
	}

	public void setBookId(String bookId) {
		this.bookId = bookId;
	}

	public String getBookCourseId() {
		return bookCourseId;
	}

	public void setBookCourseId(String bookCourseId) {
		this.bookCourseId = bookCourseId;
	}

	@Transient
	public String getQuestion() {
		return question;
	}

	public void setQuestion(String question) {
		this.question = question;
	}

	@Transient
	public String getOptionAnswer() {
		return optionAnswer;
	}

	public void setOptionAnswer(String optionAnswer) {
		this.optionAnswer = optionAnswer;
	}

	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public String getBigQuestionIndex() {
		return bigQuestionIndex;
	}

	public Integer getPageIndex() {
		return pageIndex;
	}

	public void setPageIndex(Integer pageIndex) {
		this.pageIndex = pageIndex;
	}

	public String getImage() {
		return image;
	}

	public void setImage(String image) {
		this.image = image;
	}

	public String getPrecisionPercent() {
		return precisionPercent;
	}

	public void setPrecisionPercent(String precisionPercent) {
		this.precisionPercent = precisionPercent;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public String getAuditingUserId() {
		return auditingUserId;
	}

	public void setAuditingUserId(String auditingUserId) {
		this.auditingUserId = auditingUserId;
	}

	public String getHandleUserId() {
		return handleUserId;
	}

	public void setHandleUserId(String handleUserId) {
		this.handleUserId = handleUserId;
	}

	public Integer getDealStatus() {
		return dealStatus;
	}

	public void setDealStatus(Integer dealStatus) {
		this.dealStatus = dealStatus;
	}

	public String getUnitId() {
		return unitId;
	}

	public void setUnitId(String unitId) {
		this.unitId = unitId;
	}

	public Integer getNum() {
		return num;
	}

	public void setNum(Integer num) {
		this.num = num;
	}

	public String getSmallQuestionName() {
		return smallQuestionName;
	}

	public void setSmallQuestionName(String smallQuestionName) {
		this.smallQuestionName = smallQuestionName;
	}

	public Date getPublishTime() {
		return publishTime;
	}

	public void setPublishTime(Date publishTime) {
		this.publishTime = publishTime;
	}

	@Transient
	public String getQuestionJson() {
		return questionJson;
	}

	public void setQuestionJson(String questionJson) {
		this.questionJson = questionJson;
	}

	@Transient
	public String getAnswerJson() {
		return answerJson;
	}

	public void setAnswerJson(String answerJson) {
		this.answerJson = answerJson;
	}

	public String getParentId() {
		return parentId;
	}

	public void setParentId(String parentId) {
		this.parentId = parentId;
	}

	public void setBigQuestionIndex(String bigQuestionIndex) {
		this.bigQuestionIndex = bigQuestionIndex;
	}

	public Integer getAnalysisSubmitType() {
		return analysisSubmitType;
	}

	public void setAnalysisSubmitType(Integer analysisSubmitType) {
		this.analysisSubmitType = analysisSubmitType;
	}

	public Date getAnalysisSubmitTime() {
		return analysisSubmitTime;
	}

	public void setAnalysisSubmitTime(Date analysisSubmitTime) {
		this.analysisSubmitTime = analysisSubmitTime;
	}

	public String getAnalysisUserId() {
		return analysisUserId;
	}

	public void setAnalysisUserId(String analysisUserId) {
		this.analysisUserId = analysisUserId;
	}

	@Transient
	public String getAnalysis() {
		return analysis;
	}

	public void setAnalysis(String analysis) {
		this.analysis = analysis;
	}

	public Integer getQuestionType() {
		return questionType;
	}

	public void setQuestionType(Integer questionType) {
		this.questionType = questionType;
	}

	public Integer getDifficultyLevel() {
		return difficultyLevel;
	}

	public void setDifficultyLevel(Integer difficultyLevel) {
		this.difficultyLevel = difficultyLevel;
	}

	public String getRealExamType() {
		return realExamType;
	}

	public void setRealExamType(String realExamType) {
		this.realExamType = realExamType;
	}

	public String getTrainingSkill() {
		return trainingSkill;
	}

	public void setTrainingSkill(String trainingSkill) {
		this.trainingSkill = trainingSkill;
	}

	@Transient
	public String getAnalysisJson() {
		return analysisJson;
	}

	public void setAnalysisJson(String analysisJson) {
		this.analysisJson = analysisJson;
	}

	public String getCourseName() {
		return courseName;
	}

	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}

	public String getConciseId() {
		return conciseId;
	}

	public void setConciseId(String conciseId) {
		this.conciseId = conciseId;
	}

	public String getAnalysisAuditerId() {
		return analysisAuditerId;
	}

	public void setAnalysisAuditerId(String analysisAuditerId) {
		this.analysisAuditerId = analysisAuditerId;
	}

	public Integer getEsLoaded() {
		return esLoaded;
	}

	public void setEsLoaded(Integer esLoaded) {
		this.esLoaded = esLoaded;
	}

	public Integer getIsCommonFlag() {
		return isCommonFlag;
	}

	public void setIsCommonFlag(Integer isCommonFlag) {
		this.isCommonFlag = isCommonFlag;
	}

	public Integer getQuestionYear() {
		return questionYear;
	}

	public void setQuestionYear(Integer questionYear) {
		this.questionYear = questionYear;
	}

    @Column(name = "exercise_book_id", updatable = false)
	public String getExerciseBookId() {
		return exerciseBookId;
	}

	public void setExerciseBookId(String exerciseBookId) {
		this.exerciseBookId = exerciseBookId;
	}

	public Date getHandlerSubmitTime() {
		return handlerSubmitTime;
	}

	public void setHandlerSubmitTime(Date handlerSubmitTime) {
		this.handlerSubmitTime = handlerSubmitTime;
	}

	public Date getAnalysisHandlerSubmitTime() {
		return analysisHandlerSubmitTime;
	}

	public void setAnalysisHandlerSubmitTime(Date analysisHandlerSubmitTime) {
		this.analysisHandlerSubmitTime = analysisHandlerSubmitTime;
	}


	public Integer getQuestionClassType() {
		return questionClassType;
	}

	public void setQuestionClassType(Integer questionClassType) {
		this.questionClassType = questionClassType;
	}

	public String getConciseBakId() {
		return conciseBakId;
	}

	public void setConciseBakId(String conciseBakId) {
		this.conciseBakId = conciseBakId;
	}

	@Transient
	public String getOptionAnswerText() {
		return optionAnswerText;
	}

	public void setOptionAnswerText(String optionAnswerText) {
		this.optionAnswerText = optionAnswerText;
	}

	public String getAnswerImage() {
		return answerImage;
	}

	public void setAnswerImage(String answerImage) {
		this.answerImage = answerImage;
	}

	public String getBigName() {
		return bigName;
	}

	public void setBigName(String bigName) {
		this.bigName = bigName;
	}

	public String getFromUserId() {
		return fromUserId;
	}

	public void setFromUserId(String fromUserId) {
		this.fromUserId = fromUserId;
	}

	public String getToUserId() {
		return toUserId;
	}

	public void setToUserId(String toUserId) {
		this.toUserId = toUserId;
	}

	public String getAnswerCorrecterId() {
		return answerCorrecterId;
	}

	public void setAnswerCorrecterId(String answerCorrecterId) {
		this.answerCorrecterId = answerCorrecterId;
	}

	public int getProofreadStatus() {
		return proofreadStatus;
	}

	public void setProofreadStatus(int proofreadStatus) {
		this.proofreadStatus = proofreadStatus;
	}

	public String getQuestionPath() {
		return questionPath;
	}

	public void setQuestionPath(String questionPath) {
		this.questionPath = questionPath;
	}

	public String getCourse() {
		return course;
	}

	public void setCourse(String course) {
		this.course = course;
	}

	public String getUnitName() {
		return unitName;
	}

	public void setUnitName(String unitName) {
		this.unitName = unitName;
	}

	public Integer getNumber() {
		return number;
	}

	public void setNumber(Integer number) {
		this.number = number;
	}

	public Integer getPageIndexNew() {
		return pageIndexNew;
	}

	public void setPageIndexNew(Integer pageIndexNew) {
		this.pageIndexNew = pageIndexNew;
	}

	public Integer getSortNumber() {
		return sortNumber;
	}

	public void setSortNumber(Integer sortNumber) {
		this.sortNumber = sortNumber;
	}
}

