package com.aijia.kmt.po;

import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * @author yangcan
 * 类描述:kmt题目表
 * 创建时间:2020/5/26 13:42
 */
@Entity
@Table(name="kmt_quality_questions")
@TableName(value="kmt_quality_questions")
public class KmtQualityQuestions extends BaseEntity {

	private static final long serialVersionUID = 1L;

	private String bookId;  //练习册id
	private String bookCourseId;//单元课时id
	private String question;//题目
	private String optionAnswer;//答案
	private String questionText; //题目文本
	private int updateType; // 更新类型，默认0， 3拆题新增的题目， 4题库录入的题目
	private String source;//来源, "题库录入"
	private String bigQuestionIndex;//大题号，如：一、二
	private Integer pageIndex = 1;//页码
	private String image;//图片路径
	private String precisionPercent;//识别精确率
	private String remark;//备注
	private Date createTime;//创建时间
	private String auditingUserId;//审核人
	private String handleUserId;//加工人
	private Integer dealStatus;//状态，0已录入, 1重加工, 2打回ai, 3已加工待审核, 4审核已提交，未分配解析加工人，5解析加工中，6已删除，7打回审核，8解析打回加工中，9解析审核中，10解析打回审核中，11已发布
	private String unitId;//单元id
	private Integer num = 0; //排序
	private String smallQuestionName;
	private String questionJson;
	private String answerJson;
	private Date publishTime;
	private String parentId = "";
	private String analysisUserId;
	private String analysisAuditerId;
	private String analysis;
	private Integer analysisSubmitType = 0;
	private Date analysisSubmitTime;
	private Integer questionType = 0;
	private Integer difficultyLevel = 0;
	private String realExamType;
	private String trainingSkill;
	private String analysisJson;
	private String courseName;
	private String conciseId;
	private Integer esLoaded = 0;
	/**
	 * 练习册： 0共享题，1非共享题， kmt题库：1有解析的题目， 0无解析题目
	 */
	private Integer isCommonFlag = 0;
	private Integer questionYear = 2019;

	private String exerciseBookId;

	private Date handlerSubmitTime;

	private Date analysisHandlerSubmitTime;

	/**
	 * kmt题库题目类型，0单题， 1大标题，2大标题下的小题
	 */
	private Integer questionClassType = 0;

	/**
	 * 打回时间
	 */
	private Date repulseTime;

	private String conciseBakId;

	private String optionAnswerText;

	private String answerImage;

	private String bigName;

	private String fromUserId;

	private String toUserId;

	/**
	 * 答案校对员用户id
	 */
	private String answerCorrecterId;

	/**
	 * 答案校对状态， 0未校对, 1答案正确，2答案错误, 3管理员已修改
	 */
	private int proofreadStatus;

	@TableField(exist = false)
	private int beginYear;

	@TableField(exist = false)
	private int endYear;

	@TableField(exist = false)
	private String questionProvince;

	@TableField(exist = false)
	private String questionCity;

	@TableField(exist = false)
	private String questionCountry;



	public Date getRepulseTime() {
		return repulseTime;
	}

	public void setRepulseTime(Date repulseTime) {
		this.repulseTime = repulseTime;
	}

	public String getQuestionText() {
		return questionText;
	}

	public void setQuestionText(String questionText) {
		this.questionText = questionText;
	}

	public int getUpdateType() {
		return updateType;
	}

	public void setUpdateType(int updateType) {
		this.updateType = updateType;
	}

	public String getBookId() {
		return bookId;
	}

	public void setBookId(String bookId) {
		this.bookId = bookId;
	}

	public String getBookCourseId() {
		return bookCourseId;
	}

	public void setBookCourseId(String bookCourseId) {
		this.bookCourseId = bookCourseId;
	}

	public String getQuestion() {
		return question;
	}

	public void setQuestion(String question) {
		this.question = question;
	}

	public String getOptionAnswer() {
		return optionAnswer;
	}

	public void setOptionAnswer(String optionAnswer) {
		this.optionAnswer = optionAnswer;
	}

	public String getSource() {
		return source;
	}

	public void setSource(String source) {
		this.source = source;
	}

	public String getBigQuestionIndex() {
		return bigQuestionIndex;
	}

	public Integer getPageIndex() {
		return pageIndex;
	}

	public void setPageIndex(Integer pageIndex) {
		this.pageIndex = pageIndex;
	}

	public String getImage() {
		return image;
	}

	public void setImage(String image) {
		this.image = image;
	}

	public String getPrecisionPercent() {
		return precisionPercent;
	}

	public void setPrecisionPercent(String precisionPercent) {
		this.precisionPercent = precisionPercent;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}

	public Date getCreateTime() {
		return createTime;
	}

	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}

	public String getAuditingUserId() {
		return auditingUserId;
	}

	public void setAuditingUserId(String auditingUserId) {
		this.auditingUserId = auditingUserId;
	}

	public String getHandleUserId() {
		return handleUserId;
	}

	public void setHandleUserId(String handleUserId) {
		this.handleUserId = handleUserId;
	}

	public Integer getDealStatus() {
		return dealStatus;
	}

	public void setDealStatus(Integer dealStatus) {
		this.dealStatus = dealStatus;
	}

	public String getUnitId() {
		return unitId;
	}

	public void setUnitId(String unitId) {
		this.unitId = unitId;
	}

	public Integer getNum() {
		return num;
	}

	public void setNum(Integer num) {
		this.num = num;
	}

	public String getSmallQuestionName() {
		return smallQuestionName;
	}

	public void setSmallQuestionName(String smallQuestionName) {
		this.smallQuestionName = smallQuestionName;
	}

	public Date getPublishTime() {
		return publishTime;
	}

	public void setPublishTime(Date publishTime) {
		this.publishTime = publishTime;
	}

	public String getQuestionJson() {
		return questionJson;
	}

	public void setQuestionJson(String questionJson) {
		this.questionJson = questionJson;
	}

	public String getAnswerJson() {
		return answerJson;
	}

	public void setAnswerJson(String answerJson) {
		this.answerJson = answerJson;
	}

	public String getParentId() {
		return parentId;
	}

	public void setParentId(String parentId) {
		this.parentId = parentId;
	}

	public void setBigQuestionIndex(String bigQuestionIndex) {
		this.bigQuestionIndex = bigQuestionIndex;
	}

	public Integer getAnalysisSubmitType() {
		return analysisSubmitType;
	}

	public void setAnalysisSubmitType(Integer analysisSubmitType) {
		this.analysisSubmitType = analysisSubmitType;
	}

	public Date getAnalysisSubmitTime() {
		return analysisSubmitTime;
	}

	public void setAnalysisSubmitTime(Date analysisSubmitTime) {
		this.analysisSubmitTime = analysisSubmitTime;
	}

	public String getAnalysisUserId() {
		return analysisUserId;
	}

	public void setAnalysisUserId(String analysisUserId) {
		this.analysisUserId = analysisUserId;
	}

	public String getAnalysis() {
		return analysis;
	}

	public void setAnalysis(String analysis) {
		this.analysis = analysis;
	}

	public Integer getQuestionType() {
		return questionType;
	}

	public void setQuestionType(Integer questionType) {
		this.questionType = questionType;
	}

	public Integer getDifficultyLevel() {
		return difficultyLevel;
	}

	public void setDifficultyLevel(Integer difficultyLevel) {
		this.difficultyLevel = difficultyLevel;
	}

	public String getRealExamType() {
		return realExamType;
	}

	public void setRealExamType(String realExamType) {
		this.realExamType = realExamType;
	}

	public String getTrainingSkill() {
		return trainingSkill;
	}

	public void setTrainingSkill(String trainingSkill) {
		this.trainingSkill = trainingSkill;
	}

	public String getAnalysisJson() {
		return analysisJson;
	}

	public void setAnalysisJson(String analysisJson) {
		this.analysisJson = analysisJson;
	}

	public String getCourseName() {
		return courseName;
	}

	public void setCourseName(String courseName) {
		this.courseName = courseName;
	}

	public String getConciseId() {
		return conciseId;
	}

	public void setConciseId(String conciseId) {
		this.conciseId = conciseId;
	}

	public String getAnalysisAuditerId() {
		return analysisAuditerId;
	}

	public void setAnalysisAuditerId(String analysisAuditerId) {
		this.analysisAuditerId = analysisAuditerId;
	}

	public Integer getEsLoaded() {
		return esLoaded;
	}

	public void setEsLoaded(Integer esLoaded) {
		this.esLoaded = esLoaded;
	}

	public Integer getIsCommonFlag() {
		return isCommonFlag;
	}

	public void setIsCommonFlag(Integer isCommonFlag) {
		this.isCommonFlag = isCommonFlag;
	}

	public Integer getQuestionYear() {
		return questionYear;
	}

	public void setQuestionYear(Integer questionYear) {
		this.questionYear = questionYear;
	}




	public String getExerciseBookId() {
		return exerciseBookId;
	}

	public void setExerciseBookId(String exerciseBookId) {
		this.exerciseBookId = exerciseBookId;
	}

	public Date getHandlerSubmitTime() {
		return handlerSubmitTime;
	}

	public void setHandlerSubmitTime(Date handlerSubmitTime) {
		this.handlerSubmitTime = handlerSubmitTime;
	}

	public Date getAnalysisHandlerSubmitTime() {
		return analysisHandlerSubmitTime;
	}

	public void setAnalysisHandlerSubmitTime(Date analysisHandlerSubmitTime) {
		this.analysisHandlerSubmitTime = analysisHandlerSubmitTime;
	}


	public Integer getQuestionClassType() {
		return questionClassType;
	}

	public void setQuestionClassType(Integer questionClassType) {
		this.questionClassType = questionClassType;
	}

	public String getConciseBakId() {
		return conciseBakId;
	}

	public void setConciseBakId(String conciseBakId) {
		this.conciseBakId = conciseBakId;
	}

	public String getOptionAnswerText() {
		return optionAnswerText;
	}

	public void setOptionAnswerText(String optionAnswerText) {
		this.optionAnswerText = optionAnswerText;
	}

	public String getAnswerImage() {
		return answerImage;
	}

	public void setAnswerImage(String answerImage) {
		this.answerImage = answerImage;
	}

	public String getBigName() {
		return bigName;
	}

	public void setBigName(String bigName) {
		this.bigName = bigName;
	}

	public String getFromUserId() {
		return fromUserId;
	}

	public void setFromUserId(String fromUserId) {
		this.fromUserId = fromUserId;
	}

	public String getToUserId() {
		return toUserId;
	}

	public void setToUserId(String toUserId) {
		this.toUserId = toUserId;
	}

	public String getAnswerCorrecterId() {
		return answerCorrecterId;
	}

	public void setAnswerCorrecterId(String answerCorrecterId) {
		this.answerCorrecterId = answerCorrecterId;
	}

	public int getProofreadStatus() {
		return proofreadStatus;
	}

	public void setProofreadStatus(int proofreadStatus) {
		this.proofreadStatus = proofreadStatus;
	}

	@Transient
	public int getBeginYear() {
		return beginYear;
	}

	public void setBeginYear(int beginYear) {
		this.beginYear = beginYear;
	}

	@Transient
	public int getEndYear() {
		return endYear;
	}

	public void setEndYear(int endYear) {
		this.endYear = endYear;
	}

	@Transient
	public String getQuestionProvince() {
		return questionProvince;
	}

	public void setQuestionProvince(String questionProvince) {
		this.questionProvince = questionProvince;
	}

	@Transient
	public String getQuestionCity() {
		return questionCity;
	}

	public void setQuestionCity(String questionCity) {
		this.questionCity = questionCity;
	}

	@Transient
	public String getQuestionCountry() {
		return questionCountry;
	}

	public void setQuestionCountry(String questionCountry) {
		this.questionCountry = questionCountry;
	}
}

