package com.aijia.kmt.po;

import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;

/**
 * Create by ciciwu on 2021年1月5日 下午3:59:35
 *
 * table：q_question_workbook（题目练习册关联表）
 */
@TableName(value = "q_question_workbook")
public class QuestionWorkbook extends BaseEntity
{
	private static final long serialVersionUID = -8512057190272000796L;
	
	private String bookId;//练习册ID（冗余字段，方便查询）
	private String questionId;//试题ID
	private String subBookId;//练习册子表ID
	private String courseId;//课时ID
	private int pageIndex;//页码，题目在练习册中的页码，从1开始
	private int number;//题目在练习册中的序号，从1开始，例如86，109
	private int isDiff;//是否差异的题目，1表示是，0表示不是，默认是0
	private String parentQuestionId;//父题目ID
	private String unitName;//单元名称
	private String courseName;//课时名称
	private int sortNumber;//排序字段，该字段的值为，number*1000+page_index


	public String getBookId()
	{
		return bookId;
	}
	public String getQuestionId()
	{
		return questionId;
	}
	public String getSubBookId()
	{
		return subBookId;
	}
	public String getCourseId()
	{
		return courseId;
	}
	public int getPageIndex()
	{
		return pageIndex;
	}
	public int getNumber()
	{
		return number;
	}
	public int getIsDiff()
	{
		return isDiff;
	}
	public String getParentQuestionId()
	{
		return parentQuestionId;
	}
	public String getUnitName()
	{
		return unitName;
	}
	public String getCourseName()
	{
		return courseName;
	}
	public int getSortNumber()
	{
		return sortNumber;
	}

	public void setBookId(String bookId)
	{
		this.bookId = bookId;
	}
	public void setQuestionId(String questionId)
	{
		this.questionId = questionId;
	}
	public void setSubBookId(String subBookId)
	{
		this.subBookId = subBookId;
	}
	public void setCourseId(String courseId)
	{
		this.courseId = courseId;
	}
	public void setPageIndex(int pageIndex)
	{
		this.pageIndex = pageIndex;
	}
	public void setNumber(int number)
	{
		this.number = number;
	}
	public void setIsDiff(int isDiff)
	{
		this.isDiff = isDiff;
	}
	public void setParentQuestionId(String parentQuestionId)
	{
		this.parentQuestionId = parentQuestionId;
	}
	public void setUnitName(String unitName)
	{
		this.unitName = unitName;
	}
	public void setCourseName(String courseName)
	{
		this.courseName = courseName;
	}
	public void setSortNumber(int sortNumber)
	{
		this.sortNumber = sortNumber;
	}
}
