package com.aijia.kmt.po;

import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.validator.constraints.Length;
import org.hibernate.validator.constraints.Range;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.Date;

/**
 * @apiNote 
 * 
 * @author yrf 
 * @date 2020/12/31 11:14
 */
@TableName("tb_teacher_enrollment")
@Getter
@Setter
public class TeacherEnrollment extends BaseEntity {

    private static final long serialVersionUID = -4555880365497354152L;

    @NotBlank(message = "老师姓名不能为空")
    @Length(max = 10, message = "老师姓名不能超过10个字")
    private String name;

    @NotBlank(message = "电话不能为空")
    @Pattern(regexp = "^1\\d{10}$", message = "电话格式不正确")
    private String phoneNumber;

    /**
     * 注册类型（1-社会招聘，2-高校合作，3-远程实习）
     */
    @NotNull(message = "注册类型不能为空")
    @Range(min = 1, max = 3)
    private Integer type;

    private Date createTime;

}
