package com.aijia.kmt.po.user;


import com.aijia.kmt.po.base.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableName;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.math.BigDecimal;
import java.util.Date;


@Entity
@Table(name = "tb_lib_manager")
@TableName(value = "tb_lib_manager")
public class TbLibManager extends BaseEntity {
    private static final long serialVersionUID = 1L;

    private String libId;
    /**
     * 用户id
     */
    private String userId;
    /**
     * 0:馆长，1：图书馆管理员，2：管理老师（现场管理）,3：学霸老师,4:校长，5：管理合伙人，6：一对一校长，7：一对一老师，
     * 8：在线批注老师，9:小课老师,10：学科答疑老师（学科答疑），11：校区群管理员（在线批注管理系统角色），12：超级管理员（在线批注管理系统角色），13:匹配知识点老师，
     * 14：质检员 15：机构自批注老师（作业标注） 16:家长自批注老师角色 17:录题老师 18：录题管理员
     */
    private Integer type;
    /**
     * 真实姓名
     */
    private String name;
    /**
     * 电话号码
     */
    private String telephone;
    /**
     * 性别
     */
    private Integer sex;
    /**
     * 1、家庭图书馆 2、共享图书馆
     */
    private Integer libtype;
    /**
     * 生日
     */
    private String birthday;
    private String masterId;
    private String courseName;
    /**
     * 年级
     */
    private String grade;
    /**
     * 头像
     */
    private String tPhoto;
    /**
     * 1有效-2无效
     */
    private Integer state;
    /**
     * 教龄
     */
    private Integer schoolAge;
    /**
     * 注册老师/明星老师
     */
    private String teacherLever;
    /**
     * 老师标签，分隔
     */
    private String personalLabel;

    private Date createTime;
    /**
     * 老师类型  兼职/全职
     */
    private String teacherType;
    /**
     * 个人简介
     */
    private String personalInfo;
    private String teachPoint;
    /**
     * 授课学生数
     */
    private Integer studentCount;
    /**
     * 授课次数
     */
    private Integer courseCount;
    /**
     * 好评度
     */
    private float praise;

    /**
     * 成功案例
     */
    private String successfulCase;
    /**
     * 机构id
     */
    private String orgId;
    /**
     * 机构名称
     */
    private String orgName;
    /**
     * 地址
     */
    private String address;
    /**
     * 经度
     */
    private String lon;
    /**
     * 纬度
     */
    private String lat;
    /**
     * 教师资格证书
     */
    private String certification;
    /**
     * 身份证号
     */
    private String idNum;
    /**
     * 身份证正面
     */
    private String idFace;
    /**
     * 身份证反面
     */
    private String idCon;
    /**
     * 父id（自关联）
     */
    private String parentId;
    /**
     * 学校
     */
    private String school;
    /**
     * 可批注时间段
     */
    private String period;
    /**
     * 今日当前待批注作业数量频次 (每天会将该数量清零)
     */
    private BigDecimal correctHomeworkNum;
    /**
     * 登录时间
     */
    private Date loginTime;
    /**
     * 下线时间
     */
    private Date logoutTime;
    /**
     * 分配作业时间(如果分配作业数量相同可通过该字段优先选择分配时间靠前的老师)
     */
    private Date allotTime;
    /**
     * 是否在线 1:在线，0:下线
     */
    private int isOnline;
    /**
     * 是否被封号
     */
    private int isBanned;
    /**
     * 被封时间
     */
    private Date bannedTime;
    /**
     * 是否已经注销（0：否，1：是）
     */
    private int isCancelled;
    /**
     * 注销时间
     */
    private Date cancelledTime;
    
    /**
     * 是否批注
     */
    private Integer isCorrect;
    /**
     * 专业
     */
    private String major;
    /**
     * 权限（用在录题老师(1练习册加工，2练习册审核，3练习册解析，4练习册解审，5KMT加工，6KMT审核)(多个类型以这种方式：1,2,3,4,5,6)），7题库录入老师，8答案校对老师
     */
    private String authority;
    /**
     * 是否转正
     */
    private String isFormal;

    public String getIsFormal() {
        return isFormal;
    }

    public void setIsFormal(String isFormal) {
        this.isFormal = isFormal;
    }

    public String getMajor() {
        return major;
    }

    public void setMajor(String major) {
        this.major = major;
    }

    public String getAuthority() {
        return authority;
    }

    public void setAuthority(String authority) {
        this.authority = authority;
    }

    public Date getCancelledTime() {
        return cancelledTime;
    }

    public void setCancelledTime(Date cancelledTime) {
        this.cancelledTime = cancelledTime;
    }

    public int getIsCancelled() {
        return isCancelled;
    }

    public void setIsCancelled(int isCancelled) {
        this.isCancelled = isCancelled;
    }

    public Date getBannedTime() {
        return bannedTime;
    }

    public void setBannedTime(Date bannedTime) {
        this.bannedTime = bannedTime;
    }

    public int getIsBanned() {
        return isBanned;
    }

    public void setIsBanned(int isBanned) {
        this.isBanned = isBanned;
    }

    public String gettPhoto() {
        return tPhoto;
    }

    public void settPhoto(String tPhoto) {
        this.tPhoto = tPhoto;
    }

    public String getMasterId() {
        return masterId;
    }

    public void setMasterId(String masterId) {
        this.masterId = masterId;
    }

    public String getCourseName() {
        return courseName;
    }

    public void setCourseName(String courseName) {
        this.courseName = courseName;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getLibId() {
        return libId;
    }

    public void setLibId(String libId) {
        this.libId = libId;
    }

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public Integer getSex() {
        return sex;
    }

    public void setSex(Integer sex) {
        this.sex = sex;
    }

    public Integer getLibtype() {
        return libtype;
    }

    public void setLibtype(Integer libtype) {
        this.libtype = libtype;
    }

    public String getBirthday() {
        return birthday;
    }

    public void setBirthday(String birthday) {
        this.birthday = birthday;
    }

    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }

    public Integer getSchoolAge() {
        return schoolAge;
    }

    public void setSchoolAge(Integer schoolAge) {
        this.schoolAge = schoolAge;
    }

    public String getTeacherLever() {
        return teacherLever;
    }

    public void setTeacherLever(String teacherLever) {
        this.teacherLever = teacherLever;
    }

    public String getPersonalLabel() {
        return personalLabel;
    }

    public void setPersonalLabel(String personalLabel) {
        this.personalLabel = personalLabel;
    }

    public String getTeacherType() {
        return teacherType;
    }

    public void setTeacherType(String teacherType) {
        this.teacherType = teacherType;
    }

    public String getPersonalInfo() {
        return personalInfo;
    }

    public void setPersonalInfo(String personalInfo) {
        this.personalInfo = personalInfo;
    }

    public String getTeachPoint() {
        return teachPoint;
    }

    public void setTeachPoint(String teachPoint) {
        this.teachPoint = teachPoint;
    }

    public String getSuccessfulCase() {
        return successfulCase;
    }

    public void setSuccessfulCase(String successfulCase) {
        this.successfulCase = successfulCase;
    }

    public Integer getStudentCount() {
        return studentCount;
    }

    public void setStudentCount(Integer studentCount) {
        this.studentCount = studentCount;
    }

    public Integer getCourseCount() {
        return courseCount;
    }

    public void setCourseCount(Integer courseCount) {
        this.courseCount = courseCount;
    }

    public float getPraise() {
        return praise;
    }

    public void setPraise(float praise) {
        this.praise = praise;
    }

    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getLon() {
        return lon;
    }

    public void setLon(String lon) {
        this.lon = lon;
    }

    public String getLat() {
        return lat;
    }

    public void setLat(String lat) {
        this.lat = lat;
    }

    public String getOrgId() {
        return orgId;
    }

    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }

    public String getCertification() {
        return certification;
    }

    public void setCertification(String certification) {
        this.certification = certification;
    }

    public String getIdNum() {
        return idNum;
    }

    public void setIdNum(String idNum) {
        this.idNum = idNum;
    }

    public String getIdFace() {
        return idFace;
    }

    public void setIdFace(String idFace) {
        this.idFace = idFace;
    }

    public String getIdCon() {
        return idCon;
    }

    public void setIdCon(String idCon) {
        this.idCon = idCon;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getSchool() {
        return school;
    }

    public void setSchool(String school) {
        this.school = school;
    }

    public String getPeriod() {
        return period;
    }

    public void setPeriod(String period) {
        this.period = period;
    }

    public BigDecimal getCorrectHomeworkNum() {
        return correctHomeworkNum;
    }

    public void setCorrectHomeworkNum(BigDecimal correctHomeworkNum) {
        this.correctHomeworkNum = correctHomeworkNum;
    }

    public Date getLoginTime() {
        return loginTime;
    }

    public void setLoginTime(Date loginTime) {
        this.loginTime = loginTime;
    }

    public Date getLogoutTime() {
        return logoutTime;
    }

    public void setLogoutTime(Date logoutTime) {
        this.logoutTime = logoutTime;
    }

    public Date getAllotTime() {
        return allotTime;
    }

    public void setAllotTime(Date allotTime) {
        this.allotTime = allotTime;
    }

    public int getIsOnline() {
        return isOnline;
    }

    public void setIsOnline(int isOnline) {
        this.isOnline = isOnline;
    }

	public Integer getIsCorrect() {
		return isCorrect;
	}

	public void setIsCorrect(Integer isCorrect) {
		this.isCorrect = isCorrect;
	}
    
    
    
}
