package com.aijia.kmt.service;


import com.aijia.core.security.exception.CommonException;
import com.aijia.core.web.ResponseEntity;
import com.aijia.kmt.vo.QuestionNumMarkRemoveVo;
import com.aijia.kmt.vo.rollbackai.AddExerciseQuestionRequest;
import com.aijia.kmt.vo.rollbackai.ExerciseBooksEditRequest;
import com.aijia.kmt.vo.rollbackai.ExerciseQuestionDealRequest;
import com.aijia.kmt.vo.rollbackai.ExerciseQuestionsEditRequest;

import java.io.IOException;

public interface KmtExerciseQuestionDealService {



    /**
     * 新增编辑题目
     * @param request
     * @return
     */
    ResponseEntity addOrEditExerciseQuestionOld(String userId, AddExerciseQuestionRequest request);

    /**
     * 删除题目
     * @param request
     * @return
     */
    ResponseEntity deleteExerciseQuestion(String userId, ExerciseQuestionDealRequest request);

    /**
     * 移动题目
     * @param request
     * @return
     */
    ResponseEntity moveExerciseQuestion(String userId, ExerciseQuestionDealRequest request);

    /**
     * 查询修改的练习册
     * @param request
     * @return
     */
    ResponseEntity findEditExerciseBooks(ExerciseBooksEditRequest request);


    /**
     * 查询待修改的题目
     * @param request
     * @return
     */
    ResponseEntity findEditExerciseQuestions(ExerciseQuestionsEditRequest request);

    /**
     * 删除题号
     * @param userId
     * @param request
     * @return
     */
    ResponseEntity removeQuestionNumMark (String userId, QuestionNumMarkRemoveVo request) throws CommonException, IOException;

    String  removeQuestionNumMark(int startX, int startY, int endX, int endY, String filePath) throws CommonException, IOException;


    void updateQuestionWorkBookNumber(String bookId);

    /**
     * 新增题目NEW
     * @param request
     * @return
     */
    ResponseEntity addOrEditExerciseQuestion(String userId, AddExerciseQuestionRequest request);


}
