package com.aijia.kmt.service;


import com.aijia.core.web.ResponseEntity;
import com.aijia.kmt.dto.ExerciseBookCourseClassDto;
import com.aijia.kmt.dto.ExerciseQuestionDto;
import com.aijia.kmt.dto.ExerciseQuetionDto;
import com.aijia.kmt.dto.exercise.ExerciseQuestionRollbacks;
import com.aijia.kmt.dto.exercise.QuestionAttributeFilterDto;
import com.aijia.kmt.po.KmtExerciseQuestion;
import com.aijia.kmt.vo.ExerciseQuestionsRequest;
import com.aijia.kmt.vo.ExerciseTeacherClassRequest;

import java.util.List;

public interface KmtExerciseQuestionService{

    /**
     * 查询练习册题目
     *
     * @param userId  操作人id
     * @param request 请求实体
     * @return
     */
    ResponseEntity findExerciseQuestions(String userId, ExerciseQuestionsRequest request);

    /**
     * 题目整成二级结构，添加知识点
     * @param list
     * @return
     */
    List<ExerciseBookCourseClassDto> getQuestionGroupList(List<ExerciseQuetionDto> list, boolean hasBigQuestionIndex,String userId);

    /**
     * 查询简化的分类
     * @param list
     * @param hasBigQuestionIndex
     * @return
     */
    List<ExerciseBookCourseClassDto> getSimplifyQuestionGroupList(List<ExerciseQuetionDto> list, boolean hasBigQuestionIndex);

    /**
     * kmt题目整成二级结构，添加知识点
     * @param list
     * @return
     */
    List<ExerciseBookCourseClassDto> getKmtQualityQuestionGroupList(List<ExerciseQuetionDto> list);

    /**
     * 查询角色名称
     * @param type
     * @return
     */
    String getAuthorityByType(int type);


    List<ExerciseQuestionDto> findQuestionByBookIdAndPage(String bookId, String unitId, String bookCourseId,
                                                          List<Integer> pageIndex, int bookYear);


    List<ExerciseQuestionDto> findAnswerByExerciseBookCourseId(String exerciseBookCourseId, int bookYear);


    /**
     * 查询题目的打回记录
     * @param questionId
     * @return
     */
    List<ExerciseQuestionRollbacks> findQuestionRollbackRecord(String questionId);

    /**
     * 查询题目的属性筛选项
     * @return
     */
    List<QuestionAttributeFilterDto> findQuestionAttributeFilter();


    List<ExerciseQuestionDto> findQuestionByQuestionIds(List<String> questionIds);


    boolean saveToEs(KmtExerciseQuestion kmtExerciseQuestion);

    /**
     * 批量保存kmt题目
     * @param kmtExerciseQuestions
     */
    void bulkKmtExerciseQuestions(List<KmtExerciseQuestion> kmtExerciseQuestions);

    /**
     * 保存练习册题目
     * @param kmtExerciseBookIds
     */
    void bulkBookExerciseQuestions(List<String> kmtExerciseBookIds);

    /**
     * 更新题目es, 传入练习册对象
     * @param
     */
    void updateEsQuestionHandler(List<String> kmtExerciseBookIds, String teacherId, int type);

    /**
     * 批量修改加工审核人
     * @param kmtExerciseBookIds
     * @param teachers
     */
    void updateEsQuestionHandlers(List<String> kmtExerciseBookIds, List<ExerciseTeacherClassRequest> teachers);


    /**
     * 保存es实时更新
     * @param kmtExerciseQuestion
     */
    void save2EsImmediate(KmtExerciseQuestion kmtExerciseQuestion);

    /**
     * 查询单题的es记录
     * @param id
     * @return
     */
    KmtExerciseQuestion getEsById(String id);


    void updateAnswerCorrecterIdByExerciseBookIds(String teacherId, List<String> exerciseBookIds);



    /**
     * 保存题目更新至es(包括kmt_exercise_questions、kmt_exercise_question_know索引)
     * 如果失败，最多尝试5次
     *
     * @param kmtExerciseQuestionList 练习册题目
     */
    void save2EsBatch(List<KmtExerciseQuestion> kmtExerciseQuestionList);
}
