package com.aijia.kmt.service;



import com.aijia.core.web.ResponseEntity;
import com.aijia.kmt.po.KmtExerciseBook;
import com.aijia.kmt.po.KmtExerciseQuestion;
import com.aijia.kmt.vo.AuditingV1Request;
import com.aijia.kmt.vo.QuestionPublishRequest;

import java.util.List;

public interface KmtExerciseSubmitService {

    /**
     * 新版练习册提交接口
     * @param request
     * @param userId
     * @return
     */
    ResponseEntity submit2Auditing(AuditingV1Request request, String userId);

    /**
     * 更新数据库练习册，题目，知识点
     * @param questions
     * @param book
     * @param request
     */
    void updateBookAndQuestionsAndKnow(List<KmtExerciseQuestion> questions, KmtExerciseBook book, AuditingV1Request request, String userId);

    /**
     * 数据同步es
     * @param questions
     * @param questionIds
     */
    void updateEsQuestionAndKnow(List<KmtExerciseQuestion> questions, List<String> questionIds);

    /**
     * 发布题目
     */
    ResponseEntity publishQuestion(QuestionPublishRequest request, String userId);
}
