package com.aijia.kmt.service.impl;

import com.aijia.core.utils.StringUtil;
import com.aijia.core.web.ResponseEntity;
import com.aijia.kmt.common.constant.KnowledgeVersion;
import com.aijia.kmt.dto.*;
import com.aijia.kmt.dto.exercise.*;
import com.aijia.kmt.es.service.ExerciseQuestionSearchService;
import com.aijia.kmt.es.service.base.BaseSearchService;
import com.aijia.kmt.mapper.*;
import com.aijia.kmt.po.KmtExerciseBook;
import com.aijia.kmt.po.KmtExerciseBookCourse;
import com.aijia.kmt.po.KmtExerciseQuestion;
import com.aijia.kmt.po.KmtExerciseQuestionRollback;
import com.aijia.kmt.po.user.TbLibManager;
import com.aijia.kmt.service.KmtExerciseBookService;
import com.aijia.kmt.service.KmtExerciseMapperService;
import com.aijia.kmt.service.KmtExerciseQuestionService;
import com.aijia.kmt.service.KmtExerciseService;
import com.aijia.kmt.utils.SortByChineseUtil;
import com.aijia.kmt.vo.*;
import com.aijia.train.bean.TrTrainPartUser;
import com.aijia.train.bean.TrTrainUserExercise;
import com.aijia.train.mapper.TrainUserExerciseMapper;
import com.aijia.train.mapper.TrainUserServiceMapper;
import com.alibaba.fastjson.JSON;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.apache.commons.collections4.CollectionUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.util.stream.Collectors;

@Service
public class KmtExerciseMapperServiceImpl implements KmtExerciseMapperService {

    private Logger logger = LoggerFactory.getLogger(this.getClass());

    @Autowired
    private KmtExerciseBookCourseMapper kmtExerciseBookCourseMapper;
    @Autowired
    private KmtExerciseMapper kmtExerciseMapper;
    @Autowired
    private KnowledgeVersion knowledgeVersion;
    @Autowired
    private KmtExerciseQuestionService kmtExerciseQuestionService;
    @Autowired
    private BaseSearchService baseSearchService;
    @Autowired
    private ExerciseQuestionSearchService exerciseQuestionSearchService;
    @Autowired
    private KmtExerciseService kmtExerciseService;
    @Autowired
    private KmtExerciseBookMapper kmtExerciseBookMapper;
    @Autowired
    private LibManagerMapper libManagerMapper;

    @Autowired
    private TrainUserServiceMapper  userServiceMapper;

    @Autowired
    private TrainUserExerciseMapper userExerciseMapper;

//    @Autowired
//    private KmtExerciseBookCourseMapper kmtExerciseBookCourseMapper;

    @Override
    public List<String> findWrongQuestionKnowHowDetailIdList(String questionId) {
        return kmtExerciseMapper.findWrongQuestionKnowHowDetailIdList(questionId).stream().distinct().collect(Collectors.toList());
    }


    @Override
    public List<KmtExerciseQuestion> findKmtExerciseQuestionsByIdIn(List<String> ids) {
        return kmtExerciseMapper.findKmtExerciseQuestionsByIdIn(ids);
    }

    @Override
    public List<KmtExerciseQuestion> findAllKmtExerciseQuestionsByIdIn(List<String> ids) {
        return kmtExerciseMapper.findAllKmtExerciseQuestionsByIdIn(ids);
    }

    @Override
    public void deleteKmtExerciseQuestionKnowByQuestionIds(List<String> questionIds) {
        kmtExerciseMapper.deleteKmtExerciseQuestionKnowByQuestionIds(questionIds,null);
    }

    @Override
    public void updateKmtExerciseQuestion2Review(List<String> questionIds) {
        kmtExerciseMapper.updateKmtExerciseQuestion2Review(questionIds);
    }

    @Override
    public List<ExerciseQuetionDto> findQuestionByBookCourseIdAndUserId(ExerciseQuestionsRequest request, Page page, String userId) {
//        return kmtExerciseMapper.findQuestionByBookCourseIdAndUserId(request.getPeriodId(), request.getDealType(), userId, request.getRollbackType(), 
//    	request.getExerciseBookId(), page);
    	return kmtExerciseMapper.findQuestionByBookCourseIdAndUserIdNew(request, userId, page,0,1,1);
    }

    @Override
    public List<KmtExerciseQuestionRollback> findKmtExerciseQuestionRollbacks(List<String> questionIds, int dealType) {
        return kmtExerciseMapper.findKmtExerciseQuestionRollbacks(questionIds, dealType);
    }

    @Override
    public List<KmtExerciseQuestionRollBackInfo> findQuestionRollbackRecord(String questionId) {
        return kmtExerciseMapper.findQuestionRollbackRecord(questionId);
    }

    @Override
    public List<ExerciseQuestionRollbacks> findQuestionRollbackRecordOld(String questionId) {
        return kmtExerciseMapper.findQuestionRollbackRecordOld(questionId);
    }


    @Override
    public List<KnowledgePointProportionDTO> getKnowledgePointProportionList(String vipId, String subject, Date beginDateTime, Date endDateTime) {
        String beginDateTimeStr = " 00:00:00";
        String endDateTimeStr = " 23:59:59";
        List<Map<String, Object>> knowledgeTimesMapList = new ArrayList<>();

        // 查询平台批注老师批注匹配知识点
        List<Map<String, Object>> tempKnowledgeTimesMapList = kmtExerciseMapper.countPlatformCorrectionKnowledgeTimes(vipId, subject, beginDateTimeStr, endDateTimeStr);
        if (CollectionUtils.isNotEmpty(tempKnowledgeTimesMapList)) {
            knowledgeTimesMapList.addAll(tempKnowledgeTimesMapList);
        }

        // 查询校区批注老师批注
        tempKnowledgeTimesMapList = this.countCampusCorrectionKnowledgeTimes(vipId, subject, beginDateTimeStr, endDateTimeStr);
        if (CollectionUtils.isNotEmpty(tempKnowledgeTimesMapList)) {
            knowledgeTimesMapList.addAll(tempKnowledgeTimesMapList);
        }

        List<KnowledgePointProportionDTO> knowledgePointProportionDTOList = new ArrayList<>();
        if (CollectionUtils.isEmpty(knowledgeTimesMapList)) {
            return knowledgePointProportionDTOList;
        }

        //统计所有知识点涉及总次数(每个知识点涉及次数之和)
        int allTotalCount = 0;
        for (Map<String, Object> knowledgeTimesMap : knowledgeTimesMapList) {
            allTotalCount += Integer.parseInt(knowledgeTimesMap.get("count_num").toString());
        }

        //计算每个知识点占比(自身涉及次数/所有知识点涉及总次数)
        for (Map<String, Object> knowledgeTimesMap : knowledgeTimesMapList) {
            Optional<KnowledgePointProportionDTO> optional = knowledgePointProportionDTOList.stream()
                    .filter(it -> Objects.equals(it.getKnowledgeName(), knowledgeTimesMap.get("alias")))
                    .findFirst();
            if (optional.isPresent()) {
                //已存在，说明两中批注方式均有此知识点的批注记录，累加涉及次数
                KnowledgePointProportionDTO knowledgePointProportionDTO = optional.get();
                int countNum = Integer.parseInt(knowledgeTimesMap.get("count_num").toString());
                knowledgePointProportionDTO.setCountNum(countNum + knowledgePointProportionDTO.getCountNum());
            } else {
                //记录此知识点涉及次数
                KnowledgePointProportionDTO knowledgePointProportionDTO = new KnowledgePointProportionDTO();
                knowledgePointProportionDTO.setKnowledgeName(Optional.ofNullable(knowledgeTimesMap.get("alias")).orElse("").toString());
                int countNum = Integer.parseInt(knowledgeTimesMap.get("count_num").toString());
                knowledgePointProportionDTO.setCountNum(countNum);
                knowledgePointProportionDTO.setAllTotalCount(allTotalCount);
                knowledgePointProportionDTOList.add(knowledgePointProportionDTO);
            }
        }

        //计算所有知识点占比之和，如果小于或大于1（四舍五入导致），则在第一条知识点记录中进行修正，使得占比之和为1
        BigDecimal totalProportion = BigDecimal.ZERO;
        for (KnowledgePointProportionDTO knowledgePointProportionDTO : knowledgePointProportionDTOList) {
            totalProportion = totalProportion.add(knowledgePointProportionDTO.getProportion());
        }

        knowledgePointProportionDTOList.removeIf(it -> BigDecimal.ZERO.compareTo(it.getProportion()) == 0);

        int index = 0;
        while (totalProportion.compareTo(BigDecimal.ONE) < 0) {
            if (CollectionUtils.isEmpty(knowledgePointProportionDTOList)) {
                break;
            }

            if (index >= knowledgePointProportionDTOList.size()) {
                index = 0;
            }
            KnowledgePointProportionDTO knowledgePointProportionDTO = knowledgePointProportionDTOList.get(index);
            BigDecimal increment = new BigDecimal("0.01");
            knowledgePointProportionDTO.setProportion(knowledgePointProportionDTO.getProportion().add(increment));
            totalProportion = totalProportion.add(increment);

            index ++;
        }

        return knowledgePointProportionDTOList;
    }

    /**
     * 统计校区批注知识点涉及次数
     *
     * @param vipId 学生id
     * @param subject 科目
     * @param beginDateTimeStr 开始时间
     * @param endDateTimeStr 结束时间
     */
    private List<Map<String, Object>> countCampusCorrectionKnowledgeTimes(String vipId, String subject,
                                                                          String beginDateTimeStr,
                                                                          String endDateTimeStr) {
        // 查询错题
        List<Map<String, Object>> wrongQuestionMapList = kmtExerciseMapper.findWrongQuestion(vipId, subject, beginDateTimeStr, endDateTimeStr);
        if (CollectionUtils.isEmpty(wrongQuestionMapList)) {
            return Collections.emptyList();
        }

        // 错题根据作业分组，分别统计知识点出现次数
        Map<String, List<String>> wrongQuestionIdGroupByHomeworkId = wrongQuestionMapList.stream().collect(Collectors.groupingBy(it -> Optional.ofNullable(it.get("homework_id")).map(Object::toString).orElse(""),
                Collectors.mapping(it -> Optional.ofNullable(it.get("question_id")).map(Object::toString).orElse(""), Collectors.toList())));
        List<Map<String, Object>> tempKnowledgeTimesMapList;
        List<Map<String, Object>> knowledgeTimesMapList = new ArrayList<>();
        int existCountNum;
        int tempCountNum;
        for (Map.Entry<String, List<String>> entry : wrongQuestionIdGroupByHomeworkId.entrySet()) {
            if (StringUtils.isBlank(entry.getKey()) || CollectionUtils.isEmpty(entry.getValue())) {
                continue;
            }

            tempKnowledgeTimesMapList = kmtExerciseMapper.countCampusCorrectionKnowledgeTimesByQuestionIds(entry.getValue());
            if (CollectionUtils.isNotEmpty(tempKnowledgeTimesMapList)) {
                for (Map<String, Object> tempKnowledgeTimesMap : tempKnowledgeTimesMapList) {
                    Optional<Map<String, Object>> existTempKnowledgeTimesMapOptional = knowledgeTimesMapList.stream()
                            .filter(it -> Objects.equals(it.get("alias"), tempKnowledgeTimesMap.get("alias"))).findFirst();
                    if (existTempKnowledgeTimesMapOptional.isPresent()) {
                        Map<String, Object> existTempKnowledgeTimesMap = existTempKnowledgeTimesMapOptional.get();
                        existCountNum = Integer.parseInt(existTempKnowledgeTimesMap.get("count_num").toString());
                        tempCountNum = Integer.parseInt(tempKnowledgeTimesMap.get("count_num").toString());
                        existTempKnowledgeTimesMap.put("count_num", existCountNum + tempCountNum);
                    } else {
                        knowledgeTimesMapList.add(tempKnowledgeTimesMap);
                    }
                }
            }
        }

        return knowledgeTimesMapList;
    }

    @Override
    public List<Map<String, Object>> findData2EsByQuestionList(List<String> questionIdList) {
        return kmtExerciseMapper.findData2EsByQuestionList(questionIdList);
    }

    @Override
    public long updateTotal2Es() {
        logger.info("更新es索引kmt_exercise_question_know开始");

        int pageSize = 625;
        long updateCount = 0;
        List<Map<String, Object>> dataMapList = new ArrayList<>();
        int failedCount = 0;
        boolean isContinue = true;
        boolean updateSuccess;

        do {
            if (dataMapList.isEmpty()) {
                dataMapList = kmtExerciseMapper.findAll2Es(pageSize);
                if (dataMapList.size() < pageSize) {
                    isContinue = false;
                }
            }

            if (!dataMapList.isEmpty()) {
                // 获取题目扩展信息
                kmtExerciseService.appendQuestionMapFromJSONFile(dataMapList);

                //添加到es
                updateSuccess = baseSearchService.updateOrInsertBatch("kmt_exercise_question_know", dataMapList);
                if (updateSuccess) {
                    baseSearchService.clearCache("kmt_exercise_question_know");
                    updateCount += dataMapList.size();

                    //更新加载状态为已加载
                    List<String> kmtExerciseQuestionKnowIdList = dataMapList.stream().map(it -> String.valueOf(it.get("id"))).collect(Collectors.toList());
                    kmtExerciseMapper.updateExerciseQuestionKnowEsLoadStatus(kmtExerciseQuestionKnowIdList, 1);

                    logger.info("------>已加载{}条数据", updateCount);

                    dataMapList.clear();
                } else if (failedCount < 5){
                    failedCount ++;
                } else {
                    //更新加载状态为加载失败
                    List<String> kmtExerciseQuestionKnowIdList = dataMapList.stream().map(it -> String.valueOf(it.get("id"))).collect(Collectors.toList());
                    kmtExerciseMapper.updateExerciseQuestionKnowEsLoadStatus(kmtExerciseQuestionKnowIdList, 2);
                    dataMapList.clear();
                    failedCount = 0;
                }
            }
        } while (isContinue);

        logger.info("更新es索引kmt_exercise_question_know结束，共更新{}条记录", updateCount);

        return updateCount;
    }

    @Override
    public int countQuestionByKnowledgeAndVersion(List<String> knowledgeIdList, int version) {
        return kmtExerciseMapper.countQuestionByKnowledgeAndVersion(knowledgeIdList, version);
    }

    /**
     * 获取调用ES查询所需的参数
     *
     * @param wrongQuestionKnowHowDetailIdList 错题关联的知识点id列表
     * @param needExcludedQuestionIdSet 需要排除的题目id
     * @param selectType 查询类型（1查询大题，2查询小题）
     * @param needNum 查询多少道题
     *
     * @return 示例
     * {
     * 	"query": {
     * 		"bool": {
     * 			"should": [
     *                {
     * 					"query_string": {
     * 						"default_field": "how_details_id.keyword",
     * 						"query": "dbe890a0-4c23-4ce3-95bc-01538c65f90b"
     *                    }
     *                },
     *                {
     * 					"query_string": {
     * 						"default_field": "how_details_id.keyword",
     * 						"query": "3a790f6f-4bd7-45ad-8036-3db0a7c9c8be"
     *                    }
     *                }
     * 			],
     * 			"must_not": [
     *                {
     * 					"query_string": {
     * 						"default_field": "question_id.keyword",
     * 						"query": "313a3153-d6a9-33f9-8fef-3b4da4046cc1"
     *                    }
     *                }
     * 			]
     * 		}
     * 	},
     * 	"size": 0,
     * 	"aggs": {
     * 		"group_by_question_id": {
     * 			"terms": {
     * 				"field": "question_id.keyword",
     * 				"order": {
     * 					"_count": "desc"
     *                },
     * 				"size": 2
     * 			},
     * 			"aggs": {
     * 				"result_top_hits": {
     * 					"top_hits": {
     * 						"_source": {
     * 							"includes": [
     * 								"question_id",
     * 								"num",
     * 								"question"
     * 							]
     *                        },
     * 						"size": 1
     *                    }
     *                }
     *            }
     *        }
     *  }
     * }
     */
    private Map<String, Object> getSelectParam(List<String> wrongQuestionKnowHowDetailIdList, Set<String> needExcludedQuestionIdSet, int selectType, int needNum) {
        if (CollectionUtils.isEmpty(wrongQuestionKnowHowDetailIdList)) {
            //必须先匹配知识点，未关联知识点的题目不进行推荐
            return null;
        }
        String query = "query";
        Map<String, Object> queryMap = new HashMap<>();
        //第一层
        Map<String, Object> boolMap = new HashMap<>();
        queryMap.put("bool", boolMap);
        //第二层
        List<Map<String, Object>> boolMustList = new ArrayList<>();
        boolMap.put("must", boolMustList);
        //第三层
        Map<String, Object> boolMustObj1 = new HashMap<>();
        boolMustObj1.put("exists", Collections.singletonMap("field", "book_id.keyword"));
        boolMustList.add(boolMustObj1);

        //第三层
        Map<String, Object> boolMustObj = new HashMap<>();
        boolMustList.add(boolMustObj);
        //第四层
        Map<String, Object> boolMustBoolMap = new HashMap<>();
        boolMustObj.put("bool", boolMustBoolMap);
        //第五层
        List<Map<String, Object>> boolMustBoolShouldList = new ArrayList<>();
        boolMustBoolMap.put("should", boolMustBoolShouldList);
        //第六层
        wrongQuestionKnowHowDetailIdList.forEach(knowledgeId -> {
            Map<String, Object> mustBoolShouldObj = new HashMap<>();
            boolMustBoolShouldList.add(mustBoolShouldObj);
            //第七层
            Map<String, Object> queryStringMap = new HashMap<>();
            mustBoolShouldObj.put("query_string", queryStringMap);
            queryStringMap.put("default_field", "how_details_id.keyword");
            queryStringMap.put(query, knowledgeId);
        });

        //第二层
        List<Map<String, Object>> boolMustNotList = new LinkedList<>();
        boolMap.put("must_not", boolMustNotList);
        //第三层
        Map<String, Object> boolMustNotObj1 = new HashMap<>();
        boolMustNotObj1.put("term", Collections.singletonMap("book_id.keyword", ""));
        boolMustNotList.add(boolMustNotObj1);

        //第三层
        needExcludedQuestionIdSet.forEach(needExcludedQuestionId -> {
            Map<String, Object> mustBoolMustNotObj = new HashMap<>();
            boolMustNotList.add(mustBoolMustNotObj);
            //第四层
            Map<String, Object> queryStringMap = new HashMap<>();
            mustBoolMustNotObj.put("query_string", queryStringMap);
            queryStringMap.put("default_field", "question_id.keyword");
            queryStringMap.put(query, needExcludedQuestionId);
        });
        String groupByColumn = "question_id";
        if (Objects.equals(2, selectType)) {
            groupByColumn = "parent_id";
            Map<String, Object> mustBoolMustNotObj = new HashMap<>();
            boolMustNotList.add(mustBoolMustNotObj);
            //第四层
            Map<String, Object> queryStringMap = new HashMap<>();
            mustBoolMustNotObj.put("term", queryStringMap);
            queryStringMap.put("parent_id.keyword", "");
        } else {
            //第三层
            Map<String, Object> mustBoolMustObj = new HashMap<>();
            boolMustList.add(mustBoolMustObj);
            //第四层
            Map<String, Object> queryStringMap = new HashMap<>();
            mustBoolMustObj.put("term", queryStringMap);
            queryStringMap.put("parent_id.keyword", "");
        }

        //分页
        Map<String, Object> pageMap = new HashMap<>();
        pageMap.put("size", 0);

        //聚合
        Map<String, Object> aggregationMap = JSON.parseObject("{\"group_by_question_id\":{\"terms\":{\"field\":\"" + groupByColumn + ".keyword\",\"order\":{\"_count\":\"desc\"},\"size\":" + needNum + "},\"aggs\":{\"result_top_hits\":{\"top_hits\":{\"_source\":{\"includes\":[\"question_id\",\"num\",\"parent_id\",\"question\",\"question_json\",\"book_id\"]},\"size\":1}}}}}");

        Map<String, Object> selectParamMap = new HashMap<>();
        selectParamMap.put("queryMap", queryMap);
        selectParamMap.put("aggregationMap", aggregationMap);
        selectParamMap.put("pageMap", pageMap);

        return selectParamMap;
    }

    // 判断是否包含 %
    public static boolean isSpecialChar(String str) {
        if(Objects.isNull(str)){
            return  false;
        }
        String regEx = "%";
        Pattern p = Pattern.compile(regEx);
        Matcher m = p.matcher(str);
        return m.find();
    }

    @Override
    public List<ExerciseBookDto> findExerciseBooks(ExerciseConditionRequest request, String userId) {
        List<ExerciseBookDto> list = null;
        if (isSpecialChar(request.getBookName())){
            list=new ArrayList<>();
            return list;
        }
        //查询用户
        TrTrainPartUser user = userServiceMapper.selectById(userId);
        //查询用户状态 如果是审核中4-已提交 5通过 查看之前提交的练习册
        if(user.getStudyStatus() == 4 || user.getStudyStatus() == 5){
            TrTrainUserExercise userExercise = userExerciseMapper.selectList(
                    new QueryWrapper<TrTrainUserExercise>().eq("user_id",userId)
            ).get(0);
            list = kmtExerciseMapper.findExerciseBookByQuestionId(userExercise.getExerciseId(),user.getRoleType(),user.getSubject());
            return getStaticFormatResult(list, 0);
        }else{
            list = kmtExerciseMapper.findExerciseBookByQuestionId(null,user.getRoleType(),user.getSubject());
            return getStaticFormatResult(list, 0);
        }
    }

    /**
     * 获取一个全部dto
     * @param request
     * @return
     */
    private ExerciseBookDto getAllBookDto (ExerciseConditionRequest request) {
        ExerciseBookDto all = new ExerciseBookDto();
        StringBuilder sb = new StringBuilder();
        sb.append("book_").append(request.getGrade()).append("_").append(request.getSubject()).append("_").append(request.getVersionType())
                .append("_").append(request.getSemester());
        all.setExerciseBookId(sb.toString());
        all.setName("全部");
        all.setGrade(request.getGrade());
        all.setSemester(request.getSemester());
        all.setSubject(request.getSubject());
        all.setId(sb.toString());
        String versionStr = knowledgeVersion.getVersionNameBySubjectAndVersionNum(request.getSubject(), request.getVersionType());
        ExerciseBookBaseDto version = new ExerciseBookBaseDto(request.getVersionType() + "", versionStr);
        all.setVersion(version);

        ExerciseBookTypeDto bookTypeDto = new ExerciseBookTypeDto("全部", sb.toString());
        ExerciseBookYearDto bookYearDto = new ExerciseBookYearDto("全部");
        bookYearDto.setBookTypeList(Collections.singletonList(bookTypeDto));
        all.setBookYearList(Collections.singletonList(bookYearDto));
        return all;
    }

    /**
     * 练习册名称排序
     * @param list
     * @return
     */
    private List<ExerciseBookDto> sortByBookName (List<ExerciseBookDto> list){
        if (list != null){
            Map<String, List<ExerciseBookDto>> temp = new HashMap<>();
            List<ExerciseBookDto> tempMapList;
            for (ExerciseBookDto item : list){
                if (temp.containsKey(item.getName())){
//                    temp.get(item.getName()).add(item);
                    tempMapList = temp.get(item.getName());
                    tempMapList.add(item);
                    temp.put(item.getName(), tempMapList);
                } else {
//                    temp.put(item.getName(), Collections.singletonList(item));
                    tempMapList = new ArrayList<>();
                    tempMapList.add(item);
                    temp.put(item.getName(), tempMapList);
                }
            }
            ArrayList tempList = new ArrayList(temp.keySet());
            List<String> sortList = SortByChineseUtil.sortByChinese(tempList);
            list.clear();
            for (String str : sortList) {
                list.addAll(temp.get(str));
            }
        }
        return list;
    }

    private List<ExerciseBookDto> getStaticFormatResult (List<ExerciseBookDto> list, int type){
        List<ExerciseBookDto> result = new ArrayList<>();
        if (list != null) {
            for (ExerciseBookDto bookDto : list) {
                ExerciseBookDto resultBookDto = result.stream().filter(x ->
                        bookDto.getExerciseBookId().equals(x.getExerciseBookId())).findAny().orElse(null);
                if (resultBookDto == null){
                    String versionStr = knowledgeVersion.getVersionNameBySubjectAndVersionNum(bookDto.getSubject(), bookDto.getVersionType());
                    StringBuilder bookName = new StringBuilder();
                    bookName.append(bookDto.getName()).append("(").append(versionStr.substring(0, 1)).append(")");
//                    if (bookDto.getBookType() == 1){
//                        bookName.append("(半)");
//                    }
                    bookDto.setName(bookName.toString());
                    ExerciseBookBaseDto version = new ExerciseBookBaseDto(bookDto.getVersionType() + "", versionStr);
                    bookDto.setVersion(version);

                    ExerciseBookYearDto dto = new ExerciseBookYearDto(bookDto.getBookYear());
                    dto.addBookType(bookDto.getBookType(), bookDto.getExerciseBookId());
                    if (type == 3){
                        dto.addBookPartType(bookDto.getBookType());
                    }
                    bookDto.getBookYearList().add(dto);
                    result.add(bookDto);
                } else {
                    ExerciseBookYearDto resultBookYearDto = resultBookDto.getBookYearList().stream().filter(x ->
                            x.getBookYear() == bookDto.getBookYear()).findAny().orElse(null);
                    if (resultBookYearDto == null){
                        //是新年份， 增加年份
                        resultBookDto.addBookYear(bookDto.getBookYear(), bookDto.getBookType(), bookDto.getExerciseBookId(), type);
                    } else {
                        resultBookYearDto.addBookType(bookDto.getBookType(), bookDto.getExerciseBookId());
                    }
                }
            }
            //过滤同名称的练习册,将上下半本放到同一本练习册里面（下半放到上半里面）
            Iterator<ExerciseBookDto> iterator = result.iterator();
            while (iterator.hasNext()) {
                ExerciseBookDto exerciseBookDto = iterator.next();
                for(ExerciseBookDto compareDto:result){
                    if (StringUtil.isNotEmpty(compareDto.getName()) && compareDto.getName().equals(exerciseBookDto.getName()) && !exerciseBookDto.getExerciseBookId().equals(compareDto.getExerciseBookId())) {
                        List<ExerciseBookYearDto> bookYearDtoList=compareDto.getBookYearList();
                        if(bookYearDtoList!=null&&2==exerciseBookDto.getBookYearList().get(0).getBookTypeList().get(0).getBookType()
                                &&exerciseBookDto.getGrade().equals(compareDto.getGrade())&&exerciseBookDto.getSubject().equals(compareDto.getSubject())){//下半
                            bookYearDtoList.get(0).getBookTypeList().add(exerciseBookDto.getBookYearList().get(0).getBookTypeList().get(0));
                            iterator.remove();
                            break;
                        }

                    }
                }
            }
        }
        return this.sortByBookName(result);
    }

    @Override
    public List<ExerciseBookUnitDto> findExerciseBookDetail(ExerciseBookIdDealTypeRequest request, String userId,int type) {
        List<ExerciseUnitBookcourseDto> list = null;
        List<ExerciseBookUnitDto> result = new ArrayList<>();
        TrTrainPartUser user = userServiceMapper.selectById(userId);
        //兼职
        if (user.getManagerType() == 0){
            if (StringUtil.isNotBlank(request.getQuestionId())){
                request.setQuestionId(request.getQuestionId().trim());
            }
            list = kmtExerciseMapper.findUnHandleExerciseBookCourseNew(request.getExerciseBookId(), request.getDealType(),
                    request.getQuestionId(), userId);
        } else {

            if (StringUtil.isNotBlank(request.getQuestionId())){
                list = kmtExerciseMapper.findExerciseBookCourseByQuestionIdNew(request.getQuestionId().trim());
            } else {
                if (!request.getExerciseBookId().startsWith("book_")){
                    KmtExerciseBook book = kmtExerciseBookMapper.selectById(request.getExerciseBookId());
                    if (book != null) {
                        //管理员
                        if(type == 3){
                            list = kmtExerciseMapper.findAllExerciseBookCourseByExerciseBookIdNew(book.getParentBookId(),null,null,2);//查询差异题目的单元
                        }else{
                            if (book.getBookType() == 1 || book.getBookType() == 2){
                                //上半或下半
                                list = kmtExerciseMapper.findAllExerciseBookCourseByExerciseBookIdNew(null,book.getId(),null,type);
                            } else {
                                if (request.getBookPartType() == 2){
                                    list = kmtExerciseMapper.findAllExerciseBookCourseByExerciseBookIdNew(null,book.getId(),1,type);//查询差异题目的单元
                                } else {
                                    list = kmtExerciseMapper.findAllExerciseBookCourseByExerciseBookIdNew(book.getParentBookId(),null,null,type);//查询差异题目的单元
                                }
                            }
                        }

                    }
                }
            }
        }
        if (CollectionUtils.isNotEmpty(list)){
            Map<String, List<ExerciseUnitBookcourseDto>> map = list.stream().collect(
                    Collectors.groupingBy(ExerciseUnitBookcourseDto::getId, LinkedHashMap::new, Collectors.toList()));
            for (String unitId : map.keySet()){
                ExerciseBookUnitDto bookUnitDto = new ExerciseBookUnitDto();
                bookUnitDto.setId(unitId);
                bookUnitDto.setName(map.get(unitId).get(0).getName());
                for (ExerciseUnitBookcourseDto exerciseUnitBookcourseDto : map.get(unitId)){
                    bookUnitDto.addPeriod(new ExerciseBookBaseDto(exerciseUnitBookcourseDto.getBookCourseId(), exerciseUnitBookcourseDto.getBookCourse()));
                }
                result.add(bookUnitDto);
            }
        }

        return result;
    }

    @Override
    public Map<String, Object> getKmtHandlingQuestions(KmtHandlingQuestionRequest request, String userId) {
        Page page = new Page(request.getPageNo(), request.getPageSize());
        List<ExerciseQuetionDto> questions;
        Map<String, Object> originQuestions = null;

        //模糊查询加工审核人
        List<String> userIdList = new ArrayList<>();
        if (StringUtil.isNotBlank(request.getName())) {
//            List<KmtSysUser> users = kmtSysUserService.findByName(request.getName().trim());
            List<TbLibManager> users = libManagerMapper.findByNameAndType(request.getName().trim(), 17);
            users.forEach(e -> userIdList.add(e.getUserId()));
            if(userIdList.size()==0){
                userIdList.add("noquestion");
            }
        }
        if (StringUtils.isNotBlank(request.getQuestionId())){
            //如果是小题，查询大题id出来
            request.setQuestionId(request.getQuestionId().trim());
            questions = kmtExerciseMapper.findKmtQuestionsById(request.getQuestionId(), userId, request.getDealType(), page);
        } else if (StringUtils.isNotBlank(request.getDetailId())){
            //存在知识点id的
//            questions = kmtExerciseMapper.findKmtQuestionByDetailId(request.getDetailId(), request.getPointId(), userId, request.getDealType(),userIdList, page);
            originQuestions = this.findKmtQuestionByDetailId(request, userId, userIdList);
            questions = (List<ExerciseQuetionDto>)originQuestions.get("data");
            page.setTotal(Long.parseLong(originQuestions.get("total").toString()));
        } else if (StringUtils.isNotBlank(request.getGrade())){
//            questions = kmtExerciseMapper.findKmtQuestionByGradeSubjectVersionSemester(request.getGrade(),
//                    request.getSubject(), request.getSemester(), request.getVersionType(), userId, request.getDealType(),userIdList, page);
            originQuestions = this.findKmtQuestionByGradeSubjectVersionSemester(request, userId, userIdList);
            questions = (List<ExerciseQuetionDto>)originQuestions.get("data");
            page.setTotal(Long.parseLong(originQuestions.get("total").toString()));
        } else {
            originQuestions = this.findAllKmtQuestions(userIdList, userId, request.getDealType(), request.getPageNo(), request.getPageSize());
            questions = (List<ExerciseQuetionDto>)originQuestions.get("data");
            page.setTotal(Long.parseLong(originQuestions.get("total").toString()));
//            questions = kmtExerciseMapper.findAllKmtQuestions(userId, request.getDealType(), userIdList, page);
        }
        questions = this.findAndAppendBigQuestion2List(questions);
        Map<String, Object> data  = new HashMap<>();
        data.put("pageNo", page.getCurrent());
        data.put("pageSize", page.getSize());
        data.put("pages", page.getPages());
        data.put("total", page.getTotal());
        data.put("maxCreateTime", request.getMaxCreateTime());
        data.put("list", kmtExerciseQuestionService.getQuestionGroupList(questions, false,userId));
        return data;
    }

    /**
     * 遍历列表，添加小题
     * @param questions
     * @return
     */
    private List<ExerciseQuetionDto> findAndAppendSmallQuestion2List (List<ExerciseQuetionDto> questions){
        List<ExerciseQuetionDto> result = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(questions)){
            List<ExerciseQuetionDto> smallQuestions = kmtExerciseMapper.findSmallQuestionByParentIds(questions.stream().map(ExerciseQuetionDto::getQuestionId).collect(Collectors.toList()));
            questions.stream().forEach(question -> {
                result.add(question);
                if (CollectionUtils.isNotEmpty(smallQuestions)){
                    List<ExerciseQuetionDto> target = smallQuestions.stream().filter(small ->
                            small.getParentId().equals(question.getQuestionId())).collect(Collectors.toList());
                    if (CollectionUtils.isNotEmpty(target)){
                        result.addAll(target);
                    }
                }
            });
        }
        return result;
    }

    /**
     * 遍历列表，添加大题
     * @param questions
     * @return
     */
    @Override
    public List<ExerciseQuetionDto> findAndAppendBigQuestion2List (List<ExerciseQuetionDto> questions){
        List<ExerciseQuetionDto> result = new ArrayList<>();
        List<String> parentIdList = new ArrayList<>();
        if (CollectionUtils.isNotEmpty(questions)){
            for (ExerciseQuetionDto question : questions){
                if (StringUtils.isNotBlank(question.getParentId()) && !parentIdList.contains(question.getParentId())){
                    ExerciseQuetionDto bigQuestion = kmtExerciseMapper.findBigQuestionById(question.getParentId());
                    parentIdList.add(question.getParentId());
                    if (bigQuestion != null){
                        result.add(bigQuestion);
                    }
                }
                result.add(question);
            }
        }
        return result;
    }

    /**
     * 查询kmt题目列表,废弃
     * @param findUserIds
     * @param userId
     * @param dealType
     * @param pageNo
     * @param pageSize
     * @return
     */
    private Map<String, Object> findAllKmtQuestions(List<String> findUserIds, String userId, int dealType, int pageNo, int pageSize){
//        Map<String, Object> map = exerciseQuestionSearchService.findAllKmtQuestions(findUserIds, userId, dealType, pageNo, pageSize);
        Map<String, Object> map = new HashMap<>();
        Map<String, Object> result = new HashMap<>();
        result.put("total", 0L);
        result.put("data", null);
        if (map.size() > 0){
            result.put("total", map.get("total"));
            result.put("data", this.parseMapToExerciseQuestionList((List<Map>)map.get("data")));
        }
        return result;
    }

    /**
     * es字段转成实体字段
     * @param list
     * @return
     */
    public List<ExerciseQuetionDto> parseMapToExerciseQuestionList (List<Map> list){
        List<ExerciseQuetionDto> result = new ArrayList<>();
        if (list != null){
            String bookCourseId;
            KmtExerciseBookCourse kmtExerciseBookCourse;
            for (Map map : list){
                ExerciseQuetionDto temp = new ExerciseQuetionDto();
                temp.setQuestionId(map.getOrDefault("id", "").toString());
                temp.setCourseName(map.getOrDefault("courseName", "").toString());
                temp.setHandleUserId(map.getOrDefault("handleUserId", "").toString());
                temp.setAuditingUserId(map.getOrDefault("auditingUserId", "").toString());
                temp.setAnalysisUserId(map.getOrDefault("analysisUserId", "").toString());
                temp.setAnalysisAuditerId(map.getOrDefault("analysisAuditerId", "").toString());
                bookCourseId = map.getOrDefault("bookCourseId", "").toString();
                temp.setCourseId(bookCourseId);
                if (StringUtils.isNotBlank(bookCourseId)) {
                    // 查询练习册单元课时信息
                    kmtExerciseBookCourse = kmtExerciseBookCourseMapper.selectById(bookCourseId);
                    if (kmtExerciseBookCourse != null) {
                        temp.setBookName(kmtExerciseBookCourse.getBookName());
                        temp.setUnit(kmtExerciseBookCourse.getUnit());
                        temp.setPeriod(kmtExerciseBookCourse.getPeriod());
                        temp.setGrade(kmtExerciseBookCourse.getGrade());
                        temp.setSemester(kmtExerciseBookCourse.getSemester());
                        temp.setVersionName(knowledgeVersion.getVersionNameBySubjectAndVersionNum(temp.getCourseName(), kmtExerciseBookCourse.getVersion()));
                    }
                }
                temp.setBigQuestionIndex(map.getOrDefault("bigQuestionIndex", "").toString());
                temp.setSmallQuestionIndex(Integer.parseInt(map.getOrDefault("num", "0").toString()) + "");
                temp.setQuestion(map.getOrDefault("question", "").toString());
                temp.setQuestionText(map.getOrDefault("questionText", "").toString());
                temp.setAnswer(map.getOrDefault("optionAnswer", "").toString());
                temp.setAnswerJson(map.getOrDefault("answerJson", "").toString());
                temp.setQuestionStatus(Integer.parseInt(map.getOrDefault("dealStatus", "0").toString()));
                temp.setCreateTime(map.getOrDefault("createTime", "").toString());
                temp.setReason(map.getOrDefault("remark", "").toString());
                temp.setQuestionAnalysis(map.getOrDefault("analysis", "").toString());
                temp.setAnalysisJson(map.getOrDefault("analysisJson", "").toString());
                temp.setQuestionTypes(Integer.parseInt(map.getOrDefault("questionType", "0").toString()));
                temp.setDifficultyLevels(Integer.parseInt(map.getOrDefault("difficultyLevel", "0").toString()));
                temp.setRealExamTypes(map.getOrDefault("realExamType", "").toString());
                temp.setTrainingSkills(map.getOrDefault("trainingSkill", "").toString());
                temp.setParentId(map.getOrDefault("parentId", "").toString());
                temp.setQuestionImage(map.getOrDefault("image", "").toString());
                temp.setFromUserId(map.getOrDefault("fromUserId", "").toString());
                temp.setToUserId(map.getOrDefault("toUserId", "").toString());
                temp.setUpdateType(map.getOrDefault("updateType", "").toString());
                result.add(temp);
            }
        }
        return result;
    }

    private ExerciseQuetionDto parseMapToExerciseQuestion (Map map) {
        ExerciseQuetionDto temp = new ExerciseQuetionDto();
        if (map != null){
            String bookCourseId;
            KmtExerciseBookCourse kmtExerciseBookCourse;

            temp.setQuestionId(map.getOrDefault("id", "").toString());
            temp.setCourseName(map.getOrDefault("courseName", "").toString());
            temp.setHandleUserId(map.getOrDefault("handleUserId", "").toString());
            temp.setAuditingUserId(map.getOrDefault("auditingUserId", "").toString());
            temp.setAnalysisUserId(map.getOrDefault("analysisUserId", "").toString());
            temp.setAnalysisAuditerId(map.getOrDefault("analysisAuditerId", "").toString());
            bookCourseId = map.getOrDefault("bookCourseId", "").toString();
            temp.setCourseId(bookCourseId);
            if (StringUtils.isNotBlank(bookCourseId)) {
                // 查询练习册单元课时信息
                kmtExerciseBookCourse = kmtExerciseBookCourseMapper.selectById(bookCourseId);
                if (kmtExerciseBookCourse != null) {
                    temp.setBookName(kmtExerciseBookCourse.getBookName());
                    temp.setUnit(kmtExerciseBookCourse.getUnit());
                    temp.setPeriod(kmtExerciseBookCourse.getPeriod());
                    temp.setGrade(kmtExerciseBookCourse.getGrade());
                    temp.setSemester(kmtExerciseBookCourse.getSemester());
                    temp.setVersionName(knowledgeVersion.getVersionNameBySubjectAndVersionNum(temp.getCourseName(), kmtExerciseBookCourse.getVersion()));
                }
            }
            temp.setBigQuestionIndex(map.getOrDefault("bigQuestionIndex", "").toString());
            temp.setSmallQuestionIndex(Integer.parseInt(map.getOrDefault("num", "0").toString()) + "");
            temp.setQuestion("<img src='https://img.sharingschool.com"+map.getOrDefault("image", "").toString()+"'/>");
            temp.setQuestionText(map.getOrDefault("questionText", "").toString());
            temp.setAnswer(map.getOrDefault("optionAnswer", "").toString());
            temp.setAnswerJson(map.getOrDefault("answerJson", "").toString());
            temp.setQuestionStatus(Integer.parseInt(map.getOrDefault("dealStatus", "0").toString()));
            temp.setCreateTime(map.getOrDefault("createTime", "").toString());
            temp.setReason(map.getOrDefault("remark", "").toString());
            temp.setQuestionAnalysis(map.getOrDefault("analysis", "").toString());
            temp.setAnalysisJson(map.getOrDefault("analysisJson", "").toString());
            temp.setQuestionTypes(Integer.parseInt(map.getOrDefault("questionType", "0").toString()));
            temp.setDifficultyLevels(Integer.parseInt(map.getOrDefault("difficultyLevel", "0").toString()));
            temp.setRealExamTypes(map.getOrDefault("realExamType", "").toString());
            temp.setTrainingSkills(map.getOrDefault("trainingSkill", "").toString());
            temp.setParentId(map.getOrDefault("parentId", "").toString());
            temp.setQuestionImage(map.getOrDefault("image", "").toString());
            temp.setFromUserId(map.getOrDefault("fromUserId", "").toString());
            temp.setToUserId(map.getOrDefault("toUserId", "").toString());
            temp.setUpdateType(map.getOrDefault("updateType", "").toString());
        }
        return  temp;
    }


    /**
     * 根据科目年级版本上下册查询kmt题目列表
     * @param request
     * @param userId
     * @param userIdList
     * @return
     */
    private Map<String, Object> findKmtQuestionByGradeSubjectVersionSemester (KmtHandlingQuestionRequest request, String userId, List<String> userIdList){
        Map<String, String> param = new HashMap<>();
        param.put("dealType", request.getDealType() + "");
        param.put("pageNo", request.getPageNo() + "");
        param.put("pageSize", request.getPageSize() + "");
        param.put("courseName", request.getSubject());
        param.put("grade", request.getGrade());
        param.put("semester", request.getSemester() + "");
        param.put("versionType", request.getVersionType() + "");
        Map<String, Object> result;
        result = exerciseQuestionSearchService.findKmtQuestionByGradeSubjectVersionSemester(param, userId, userIdList);
        result.put("data", this.parseKnowMapToExerciseQuestionList((List)result.get("data")));
        return result;
    }

    /**
     * es kmt_exercise_question_know 索引的字段转成实体字段
     * @param list
     * @return
     */
    private List<ExerciseQuetionDto> parseKnowMapToExerciseQuestionList (List<Map> list){
        List<ExerciseQuetionDto> result = new ArrayList<>();
        if (list != null){
            for (Map map : list){
                ExerciseQuetionDto temp = new ExerciseQuetionDto();
                temp.setQuestionId(map.getOrDefault("question_id", "").toString());
                temp.setCourseName(map.getOrDefault("course_name", "").toString());
                temp.setHandleUserId(map.getOrDefault("handle_user_id", "").toString());
                temp.setAuditingUserId(map.getOrDefault("auditing_user_id", "").toString());
                temp.setAnalysisUserId(map.getOrDefault("analysis_user_id", "").toString());
                temp.setAnalysisAuditerId(map.getOrDefault("analysis_auditer_id", "").toString());
                temp.setCourseId(map.getOrDefault("book_course_id", "").toString());
                temp.setBigQuestionIndex(map.getOrDefault("bigQuestion_index", "").toString());
                temp.setSmallQuestionIndex(Integer.parseInt(map.getOrDefault("num", "0").toString()) + "");
                temp.setQuestion(map.getOrDefault("question", "").toString());
                temp.setQuestionText(map.getOrDefault("question_text", "").toString());
                temp.setAnswer(map.getOrDefault("option_answer", "").toString());
                temp.setAnswerJson(map.getOrDefault("answer_json", "").toString());
                temp.setQuestionStatus(Integer.parseInt(map.getOrDefault("deal_status", "0").toString()));
//                temp.setCreateTime(map.getOrDefault("create_time", "").toString());
                temp.setReason(map.getOrDefault("remark", "").toString());
                temp.setQuestionAnalysis(map.getOrDefault("analysis", "").toString());
                temp.setAnalysisJson(map.getOrDefault("analysis_json", "").toString());
                temp.setQuestionTypes(Integer.parseInt(map.getOrDefault("question_type", "0").toString()));
                temp.setDifficultyLevels(Integer.parseInt(map.getOrDefault("difficulty_level", "0").toString()));
                temp.setRealExamTypes(map.getOrDefault("real_exam_type", "").toString());
                temp.setTrainingSkills(map.getOrDefault("training_skill", "").toString());
                temp.setParentId(map.getOrDefault("parent_id", "").toString());
                temp.setQuestionImage(map.getOrDefault("image", "").toString());
                temp.setFromUserId(map.getOrDefault("from_user_id", "").toString());
                temp.setToUserId(map.getOrDefault("to_user_id", "").toString());
                temp.setUpdateType(map.getOrDefault("update_type", "").toString());
                result.add(temp);
            }
        }
        return result;
    }

    /**
     * 根据知识点考点查询kmt题目
     * @param request
     * @param userId
     * @param userIdList
     * @return
     */
    private Map<String, Object> findKmtQuestionByDetailId(KmtHandlingQuestionRequest request, String userId, List<String> userIdList){
        Map<String, String> param = new HashMap<>();
        param.put("dealType", request.getDealType() + "");
        param.put("pageNo", request.getPageNo() + "");
        param.put("pageSize", request.getPageSize() + "");
        param.put("detailId", request.getDetailId());
        param.put("pointId", request.getPointId());
        Map<String, Object> result;
        result = exerciseQuestionSearchService.findKmtQuestionByDetailId(param, userId, userIdList);
        result.put("data", this.parseKnowMapToExerciseQuestionList((List)result.get("data")));
        return result;
    }


    @Override
    public ResponseEntity findQuestionListByParentId(List<String> parentIds) {
        ResponseEntity responseEntity = new ResponseEntity();
        List<ExerciseQuetionDto> questions = new ArrayList<>();
        List<Map> questionTmps;
        List<ExerciseQuetionDto> exerciseQuetionDtos;
        if (CollectionUtils.isNotEmpty(parentIds)){
            for (String parentId : parentIds){
                questionTmps = exerciseQuestionSearchService.findKmtQuestionsByParentId(parentId);
                exerciseQuetionDtos = this.parseMapToExerciseQuestionList(questionTmps);
                if (CollectionUtils.isNotEmpty(exerciseQuetionDtos)){
                    questions.addAll(exerciseQuetionDtos);
                }
            }
        }
        Map<String, Object> data  = new HashMap<>();
        data.put("list", kmtExerciseQuestionService.getQuestionGroupList(questions, false,null));
        responseEntity.success(data, "查询成功");
        return responseEntity;
    }

    @Override
    public List<ExerciseBookUnitDto> findUnitAndPeriodList(UnitAndPeriodListRequest request) {
        List<ExerciseBookUnitDto> result = new ArrayList<>();
        List<ExerciseUnitBookcourseDto> list = kmtExerciseMapper.findUnitAndPeriodList(request);

        if (CollectionUtils.isNotEmpty(list)){
            Map<String, List<ExerciseUnitBookcourseDto>> map = list.stream().collect(
                    Collectors.groupingBy(ExerciseUnitBookcourseDto::getId, LinkedHashMap::new, Collectors.toList()));
            for (String unitId : map.keySet()){
                ExerciseBookUnitDto bookUnitDto = new ExerciseBookUnitDto();
                bookUnitDto.setId(unitId);
                bookUnitDto.setName(map.get(unitId).get(0).getName());
                for (ExerciseUnitBookcourseDto exerciseUnitBookcourseDto : map.get(unitId)){
                    bookUnitDto.addPeriod(new ExerciseBookBaseDto(exerciseUnitBookcourseDto.getBookCourseId(), exerciseUnitBookcourseDto.getBookCourse()));
                }
                result.add(bookUnitDto);
            }
        }

        return result;
    }

    @Override
    public List<ExerciseBookCourseClassDto> findClassifyQuestionsByIds(List<String> questionIds) {
        List<Map> tmpList = exerciseQuestionSearchService.findAllExerciseQuestionsByQuestionIds(questionIds);
//        List<ExerciseQuetionDto> temps = this.parseMapToExerciseQuestionList(tmpList);
        List<ExerciseQuetionDto> questions = new ArrayList<>();
        ExerciseQuetionDto qTmp = null;
//        for (String questionId : questionIds){
//            for (ExerciseQuetionDto temp : temps){
//                if (questionId.equals(temp.getQuestionId())){
//                    qTmp = new ExerciseQuetionDto();
//                    BeanUtils.copyProperties(temp, qTmp);
//                    questions.add(temp);
//                    break;
//                }
//            }
//        }
        if (tmpList != null){
            for (String questionId : questionIds){
                for (Map map : tmpList){
                    if (questionId.equals(map.getOrDefault("id", "").toString())){
                        questions.add(this.parseMapToExerciseQuestion(map));
                        break;
                    }
                }
            }
        }
        return kmtExerciseQuestionService.getSimplifyQuestionGroupList(questions, false);
    }

    @Override
    public List<KmtExerciseBookLibDto> findOrgCount(String libId, String subject){
        return kmtExerciseMapper.findAllExerciseBook(libId,subject);
    }
}
