package com.aijia.kmt.task;

import com.aijia.kmt.common.taskthread.AijiaThreadPool;
import com.aijia.kmt.service.KmtExerciseQuestionDealService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.Callable;

public class SyncUpdateQuestionWorkbookNumber implements Callable<Integer> {

    private final Logger logger = LoggerFactory.getLogger(this.getClass());

    private String bookId = null;

    private KmtExerciseQuestionDealService kmtExerciseQuestionDealService;

    public SyncUpdateQuestionWorkbookNumber(String bookId, KmtExerciseQuestionDealService kmtExerciseQuestionDealService) {
        this.bookId = bookId;
        this.kmtExerciseQuestionDealService = kmtExerciseQuestionDealService;
    }

    @Override
    public Integer call() {
        try{
            StringBuilder sb = new StringBuilder();
            sb.append("线程池中正在执行任务的线程数量=").append(AijiaThreadPool.getInstance().getActiveCount())
                    .append(";创建过的最大线程数量=").append(AijiaThreadPool.getInstance().getLargestPoolSize())
                    .append(";线程池当前的线程数量=").append(AijiaThreadPool.getInstance().getPoolSize());
            logger.info(sb.toString());
            kmtExerciseQuestionDealService.updateQuestionWorkBookNumber(bookId);
        } catch (Exception e){
            logger.error("更新number异常", e);
        }
        return 1;
    }
}
