package com.aijia.kmt.vo;

import io.swagger.annotations.ApiModelProperty;

import javax.validation.constraints.Pattern;

/**
 * @author Mount Liu
 * @date 2020/5/11
 */
public class CheckedExerciseBookReq extends PageReq {

    private static final long serialVersionUID = 6011152528578070581L;

    @ApiModelProperty(name = "teacherName", value = "老师名字", required = true)
    private String teacherName;

    @ApiModelProperty(name = "exerciseName", value = "练习册名字", required = true)
    private String exerciseName;

    @Pattern(regexp = "\\d{4}-\\d{2}-\\d{2}")
    @ApiModelProperty(name = "beginTime", value = "开始日期(yyyy-MM-dd)", required = true)
    private String beginTime;

    @Pattern(regexp = "\\d{4}-\\d{2}-\\d{2}")
    @ApiModelProperty(name = "endTime", value = "结束日期(yyyy-MM-dd)", required = true)
    private String endTime;

    @ApiModelProperty(name = "subject", value = "科目", required = true)
    private String subject;

    @ApiModelProperty(name = "grade", value = "年级", required = true)
    private String grade;

    @ApiModelProperty(name = "semester", value = "上下册，1上2下", required = true)
    private String semester;

    @ApiModelProperty(name = "versionType", value = "版本类别, 如语文1北师大版，2人教版", required = true)
    private String  versionType;

    @ApiModelProperty(name = "bookType", value = "类型：0-整本，1-上半，2-下半，3-不同", required = true)
    private String  bookType;

    @Pattern(regexp = "\\d{4}-\\d{2}-\\d{2}")
    @ApiModelProperty(name = "allotCheckTime", value = "分配校对时间（yyyy-MM-dd）", required = true)
    private String allotCheckTime;

    public String getAllotCheckTime() {
        return allotCheckTime;
    }

    public void setAllotCheckTime(String allotCheckTime) {
        this.allotCheckTime = allotCheckTime;
    }

    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public String getGrade() {
        return grade;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public String getSemester() {
        return semester;
    }

    public void setSemester(String semester) {
        this.semester = semester;
    }

    public String getVersionType() {
        return versionType;
    }

    public void setVersionType(String versionType) {
        this.versionType = versionType;
    }

    public String getBookType() {
        return bookType;
    }

    public void setBookType(String bookType) {
        this.bookType = bookType;
    }

    public String getTeacherName() {
        return teacherName;
    }

    public void setTeacherName(String teacherName) {
        this.teacherName = teacherName;
    }

    public String getBeginTime() {
        return beginTime;
    }

    public void setBeginTime(String beginTime) {
        this.beginTime = beginTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public String getExerciseName() {
        return exerciseName;
    }

    public void setExerciseName(String exerciseName) {
        this.exerciseName = exerciseName;
    }
}
