package com.aijia.kmt.vo.papercreate;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;


@Data
public class PaPerCreateVo2 {
    private final static long serialVersionUID = 1L;

    @ApiModelProperty(name = "grade", value = "年级", required = true)
    @NotBlank(message = "年级不能为空")
    private String grade;

    @ApiModelProperty(name = "subject", value = "科目", required = true)
    @NotBlank(message = "科目不能为空")
    private String subject;


    @ApiModelProperty(name = "versionType", value = "版本号", required = true)
    @Min(value = 1, message = "版本错误")
    private int versionType;


    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public void setVersionType(int versionType) {
        this.versionType = versionType;
    }


    public String getGrade() {
        return grade;
    }

    public String getSubject() {
        return subject;
    }

    public int getVersionType() {
        return versionType;
    }

}
