package com.aijia.kmt.vo.papercreate;

import com.aijia.core.web.BaseRequest;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotEmpty;
import java.util.List;

@Data
public class PaperCreateVo extends BaseRequest {

    private final static long serialVersionUID = 1L;

    @ApiModelProperty(name = "grade", value = "年级", required = true)
    @NotBlank(message = "年级不能为空")
    private String grade;

    @ApiModelProperty(name = "subject", value = "科目", required = true)
    @NotBlank(message = "科目不能为空")
    private String subject;


    @ApiModelProperty(name = "versionType", value = "版本号", required = true)
    @Min(value = 1, message = "版本错误")
    private int versionType;

    @ApiModelProperty(name = "questionTypes", value = "题型", required = true)
    @NotEmpty(message = "题型必选")
    private List<QuestionTypeVo> questionTypes;

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }

    public void setGrade(String grade) {
        this.grade = grade;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public void setVersionType(int versionType) {
        this.versionType = versionType;
    }

    public void setQuestionTypes(List<QuestionTypeVo> questionTypes) {
        this.questionTypes = questionTypes;
    }

    public String getGrade() {
        return grade;
    }

    public String getSubject() {
        return subject;
    }

    public int getVersionType() {
        return versionType;
    }

    public List<QuestionTypeVo> getQuestionTypes() {
        return questionTypes;
    }

}
