package com.aijia.kmt.vo.papercreate;

import com.aijia.core.web.BaseRequest;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import javax.validation.constraints.Min;
import javax.validation.constraints.NotBlank;

@Data
public class QuestionExchangeVo extends BaseRequest {

    private final static long serialVersionUID = 1L;

    @ApiModelProperty(name = "grade", value = "年级", required = true)
    @NotBlank(message = "年级不能为空")
    private String grade;

    @ApiModelProperty(name = "grade", value = "年级", required = true)
    @NotBlank(message = "年级不能为空")
    private String subject;

    @ApiModelProperty(name = "versionType", value = "版本", required = true)
    @Min(value = 1, message = "版本必须大于0")
    private int versionType;

    @ApiModelProperty(name = "questionType", value = "题型", required = true)
    @Min(value = 1, message = "题型必须大于0")
    private int questionType;

    @ApiModelProperty(name = "questionDifficultLevel", value = "难度", required = true)
    @Min(value = 1, message = "难度必须大于0")
    private int questionDifficultLevel;

    @ApiModelProperty(name = "pageNo", value = "页码", required = true)
    @Min(value = 1, message = "页码必须大于0")
    private int pageNo;

    @ApiModelProperty(name = "grade", value = "年级", required = false)
    private String pointId;

}
