package com.aijia.train.bean;

import com.aijia.kmt.po.base.BaseEntity;

import javax.persistence.Entity;
import javax.persistence.Table;

/**
 * @author sh
 * @className TrainUserExerciseInfo
 * @description 用户培训相关
 * @date 2021/7/27
 */
@Entity
@Table(name="tr_train_user_exercise")
public class TrTrainUserExercise extends BaseEntity {

    private String userId;

    /**
     * 练习册id
     */
    private String exerciseId;

    /**
     * 题目id
     */
    private String questionId;

    private String questionOrg;

    private String question;

    private String questionText;

    private String questionJson;

    private String answer;

    private String answerText;

    private String answerJson;

    private String analysis;

    private String analysisJson;

    private String updateTime;

    private String createTime;

    private int status;

    private String des;

    /**
     * 题目类型，1：选择题2：多选项3：填空题4：简答题6：计算题7：作文题8：判断题9：连线题10：
     * 翻译题11：匹配题12：阅读题13：语音题14：操作题16：课外阅读题17：解决问题18：看图列式19：情景交际
     */
    private Integer questionType = 0;

    /**
     * 真题，例题类型，1例题，2真题，3练习题
     */
    private String realExamType;

    /**
     * 难度级别
     */
    private Integer difficultyLevel = 0;

    /**
     * //训练的技能
     */
    private String trainingSkill;

    /**
     *update kmt_exercise_questions set concise_id=#{startX}, analysis_submit_type=#{startY}, update_type=#{endX}," +
     *             " es_loaded=#{endY}, enumerate=#{enumerate} where id=#{questionId}
     * `concise_id` int DEFAULT '0' COMMENT '年级科目版本信息id',
     * `analysis_submit_type` int DEFAULT '0' COMMENT '解析加工的类型：0未解析，1已提交解析',
     *`update_type` int DEFAULT '0' COMMENT '更新类型，默认0，1更新答案文本',
     *`es_loaded` smallint NOT NULL DEFAULT '0' COMMENT '是否已加载到es（-1关联教辅不存在；0未加载；1已加载；2加载失败）',
     * `enumerate` int NOT NULL DEFAULT '1' COMMENT '1 有题号需要去 ，2 有题号不需要去 ，3其他',
     * `question_path` varchar(100) CHARACTER SET utf8mb4 COLLATE utf8mb4_general_ci DEFAULT NULL,
     */

    private int conciseId;

    private int analysisSubmitType;

    private int updateType;

    private int esLoaded;

    private int enumerate;

    /**
     * 题目图片路径
     */
    private String questionPath;

    public String getUserId() {
        return userId;
    }

    public void setUserId(String userId) {
        this.userId = userId;
    }

    public String getExerciseId() {
        return exerciseId;
    }

    public void setExerciseId(String exerciseId) {
        this.exerciseId = exerciseId;
    }

    public String getQuestionId() {
        return questionId;
    }

    public void setQuestionId(String questionId) {
        this.questionId = questionId;
    }

    public String getQuestionOrg() {
        return questionOrg;
    }

    public void setQuestionOrg(String questionOrg) {
        this.questionOrg = questionOrg;
    }

    public String getQuestion() {
        return question;
    }

    public void setQuestion(String question) {
        this.question = question;
    }

    public String getQuestionText() {
        return questionText;
    }

    public void setQuestionText(String questionText) {
        this.questionText = questionText;
    }

    public String getQuestionJson() {
        return questionJson;
    }

    public void setQuestionJson(String questionJson) {
        this.questionJson = questionJson;
    }

    public String getAnswer() {
        return answer;
    }

    public void setAnswer(String answer) {
        this.answer = answer;
    }

    public String getAnswerText() {
        return answerText;
    }

    public void setAnswerText(String answerText) {
        this.answerText = answerText;
    }

    public String getAnswerJson() {
        return answerJson;
    }

    public void setAnswerJson(String answerJson) {
        this.answerJson = answerJson;
    }

    public String getAnalysis() {
        return analysis;
    }

    public void setAnalysis(String analysis) {
        this.analysis = analysis;
    }

    public String getAnalysisJson() {
        return analysisJson;
    }

    public void setAnalysisJson(String analysisJson) {
        this.analysisJson = analysisJson;
    }

    public String getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(String updateTime) {
        this.updateTime = updateTime;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public int getStatus() {
        return status;
    }

    public void setStatus(int status) {
        this.status = status;
    }

    public String getDes() {
        return des;
    }

    public void setDes(String des) {
        this.des = des;
    }

    public Integer getQuestionType() {
        return questionType;
    }

    public void setQuestionType(Integer questionType) {
        this.questionType = questionType;
    }

    public String getRealExamType() {
        return realExamType;
    }

    public void setRealExamType(String realExamType) {
        this.realExamType = realExamType;
    }

    public Integer getDifficultyLevel() {
        return difficultyLevel;
    }

    public void setDifficultyLevel(Integer difficultyLevel) {
        this.difficultyLevel = difficultyLevel;
    }

    public String getTrainingSkill() {
        return trainingSkill;
    }

    public void setTrainingSkill(String trainingSkill) {
        this.trainingSkill = trainingSkill;
    }

    public int getConciseId() {
        return conciseId;
    }

    public void setConciseId(int conciseId) {
        this.conciseId = conciseId;
    }

    public int getAnalysisSubmitType() {
        return analysisSubmitType;
    }

    public void setAnalysisSubmitType(int analysisSubmitType) {
        this.analysisSubmitType = analysisSubmitType;
    }

    public int getUpdateType() {
        return updateType;
    }

    public void setUpdateType(int updateType) {
        this.updateType = updateType;
    }

    public int getEsLoaded() {
        return esLoaded;
    }

    public void setEsLoaded(int esLoaded) {
        this.esLoaded = esLoaded;
    }

    public int getEnumerate() {
        return enumerate;
    }

    public void setEnumerate(int enumerate) {
        this.enumerate = enumerate;
    }

    public String getQuestionPath() {
        return questionPath;
    }

    public void setQuestionPath(String questionPath) {
        this.questionPath = questionPath;
    }
}
