package com.aijia.train.service;

import com.aijia.core.web.ResponseEntity;
import com.aijia.train.bean.TrTrainPartUser;
import com.aijia.train.vo.FileVO;

import java.util.List;
import java.util.Map;

/**
 * @author sh
 * @className ITrainService
 * @description service
 * @date 2021/7/26
 */
public interface ITrainService {
    /**
     * 根据手机号码查找用户
     * @param loginName
     * @return
     */
    TrTrainPartUser getTrainUserByMobile(String loginName, int type,String password);

    /**
     * 发送短信
     * @param mobile
     * @return
     */
    ResponseEntity sendSmsV2(String mobile);

    /**
     * 检查短信验证码是否正确
     * @param trim
     * @param msgCode
     * @return
     */
    ResponseEntity confirmSms(String trim, String msgCode);

    /**
     * 根据id查找用户
     * @param userId
     * @return
     */
    TrTrainPartUser getUserById(String userId);

    /**
     * 根据用户id查找学习文件列表
     * @param userId
     * @return
     */
    List<FileVO> findTrainFileList(String userId,int roleType);

    /**
     * 解锁下个视频
     * @param id
     * @param roleType
     * @param subject
     */
    ResponseEntity unlockNextFile(String id, Integer roleType, String subject,String userId);

    /**
     * 开始学习
     * @param roleType
     * @param subject
     * @param userId
     */
    void startStudy(Integer roleType, String subject, String userId);

    /**
     * 查找各个状态的兼职老师
     * @param roleType
     * @param subject
     * @param type
     * @return
     */
    List<Map<String, Object>> partTeacherList(Integer roleType, String subject, Integer type);

    /**
     * 重新学习
     * @param id
     */
    void studyAgain(String id);

    /**
     * 考核
     * @param type
     */
    void teacherAudit(Integer type,String userId);

    /**
     * 编辑资料
     * @param userId
     * @param name
     * @param roleType
     * @param subject
     * @return
     */
    ResponseEntity teacherInfoEdit(String userId, String name, Integer roleType, String subject);

    ResponseEntity saveCheckQuestion(List<String> questionIds, TrTrainPartUser user);
}
